#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <gtk/gtk.h>
//#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include <tiffio.h>
#include <tiff.h>

// APA

#define ACTIF 1
#define INACTIF 0

//#include "../apa/apa.h"
#include "../apa-trt/api.h"

#include <time.h>

enum
  {
    FCT_NORM,
    FCT_BIN,
    FCT_SQRT,
    FCT_ASINH
  };

typedef float (* _FctVisu)(float);
_FctVisu  DefFctVisu();    

enum
{
  COLUMN_NAME,
  COLUMN_DESCRIPTION,
  COLUMN_FILE,
  NUM_COLUMNS
};

enum
{
  FILTRE_TOGGLE,
  FILTRE_NAME,
  FILTRE_X,
  FILTRE_Y,
  FILTRE_L,
  FILTRE_H,
  FILTRE_FILE,
  FILTRE_NUM_COLUMNS
};

enum
{
  PARAM_NAME,
  PARAM_DESC,
  PARAM_VALEUR,
  PARAM_NUM_COLUMNS
};

typedef int  (* Fonction)(struct image *,
			  struct image * ,
			  int , int ,
			  int , int ,
			  struct parametre * );


typedef struct parametre * (* InitParam)();

typedef struct filtre * (* A_Name)();
typedef struct parametre  * (* A_Init)();
typedef char *  (* A_Version)();

gchar *  plugins_path;

struct Selection
{
  int etat;
  int x1;
  int y1;
  int x2;
  int y2;
};

struct Selection selection;

gchar *ConvParamChar(struct parametre * p)
{
  gchar *val;
  switch (p->type)
    {
    case INT:
      val = g_strdup_printf("%i",p->intvalue);
      break;
    case FLOAT:
      val = g_strdup_printf("%f",p->floatvalue);
      break;
    case STRING:
    case POURC:
    default:
      val = g_strdup_printf("%s","A faire");
      break;
    }
  return val;
  
}

void ConvCharParam(struct parametre *p,gchar *t)
{
  gdouble v;
  switch (p->type)
    {
    case INT:
      v=g_ascii_strtod(t,NULL);
      p->intvalue = (int)v;
      break;
    case FLOAT:
      v=g_ascii_strtod(t,NULL);
      p->floatvalue = (float)v;
      break;
    case STRING:
    case POURC:
    default:
      break;
    }
}


static void
put_pixel (GdkPixbuf *pixbuf, int x, int y, guchar red, guchar green, guchar blue, guchar alpha)
{
  int width, height, rowstride, n_channels;
  guchar *pixels, *p;

  n_channels = gdk_pixbuf_get_n_channels (pixbuf);

  g_assert (gdk_pixbuf_get_colorspace (pixbuf) == GDK_COLORSPACE_RGB);
  g_assert (gdk_pixbuf_get_bits_per_sample (pixbuf) == 8);
  g_assert (gdk_pixbuf_get_has_alpha (pixbuf));
  g_assert (n_channels == 4);

  width = gdk_pixbuf_get_width (pixbuf);
  height = gdk_pixbuf_get_height (pixbuf);

  /* g_assert (x >= 0 ); */
/*   g_assert (y >= 0 ); */
/*   g_assert (x < width); */
/*   g_assert (y < height); */

  rowstride = gdk_pixbuf_get_rowstride (pixbuf);
  pixels = gdk_pixbuf_get_pixels (pixbuf);

  p = pixels + y * rowstride + x * n_channels;
  p[0] = red;
  p[1] = green;
  p[2] = blue;
  p[3] = alpha;
}
void HistoPixbuf();
static GdkPixbuf *hstRGB = NULL;
static GdkPixbuf *hstR = NULL;
static GdkPixbuf *hstG = NULL;
static GdkPixbuf *hstB = NULL;

/* Pixmap d'arrière-plan pour la zone de dessin */
static GdkPixbuf *pixbuf = NULL;
struct image im;
float seuil_b=0.0;
float seuil_f=0.0;
float seuil_h=3000.0;
float facteur=1;
gint vp_l=0;
gint vp_h=0;
gchar *nomImage=NULL;
gint fct_courante=FCT_NORM;

/*  float d = seuil_h-seuil_f; */
/* float a = (R-seuil_f)/d; */
/* 	  if ((xF==100)&&(yF==100)) */
/* 	    { */
/* 	      printf("a=%f R=%i\n",a,R);fflush(stdout); */
/* 	    } */
/* 	  if (fct_courante==FCT_SQRT)  a = sqrt(a); */
/* 	  if (fct_courante==FCT_ASINH) a = asinh(10.0*a)/asinh(10.0); */
/* 	  a=a*d+seuil_f; */


float FctNorm(float a)
{
  return a;
}

float FctBin(float a)
{
  return a>seuil_f?seuil_h:seuil_b;
}

float FctSqrt(float a)
{
  if (a>seuil_f) 
    {
      // On recale sur le zero et on normalise
      a =(a-seuil_f)/(seuil_h-seuil_f);
      a = sqrt(a);
      // On redeploie
      a =a * (seuil_h-seuil_f)+seuil_f;
    }
  return a;
}
float FctAsinh(float a)
{
  if (a>seuil_f) 
    {
      // On recale sur le zero et on normalise
      a =(a-seuil_f)/(seuil_h-seuil_f);
      a = asinh(10.0*a)/asinh(10.0);
      // On redeploie
      a =a * (seuil_h-seuil_f)+seuil_f;
    }
  return a;
}
 
_FctVisu DefFctVisu()
{
  switch(fct_courante)
    {
    case FCT_NORM:
      return &FctNorm; break;
    case FCT_BIN:
      return &FctBin; break;
    case FCT_SQRT:
      return &FctSqrt; break;
    case FCT_ASINH:
      return &FctAsinh; break;
    default:
      return NULL;
    }
}


float FonctionVisualisation(float a)
{
  if (a>seuil_f) 
    {
      // On recale sur le zero et on normalise
      a =(a-seuil_f)/(seuil_h-seuil_f);
      if (fct_courante==FCT_SQRT)  a = sqrt(a);
      if (fct_courante==FCT_ASINH) a = asinh(10.0*a)/asinh(10.0);
      
      // On redeploie
      a =a * (seuil_h-seuil_f)+seuil_f;
    }
  
  return a;
}

gdouble calculRGB( _ImVal ImVal, _FctVisu FctVisu,
		   int x, int y,gdouble  vMax, float t,
		   guchar * red, guchar * green,guchar * blue )
{
  uint16 R,G,B;
  gdouble v;
  
  (ImVal)(&im,x,y,&R,&G,&B);

  float r,g,b;
  
  r=R;
  g=G;
  b=B;
  
  uint16 I = (r+g+b)/3;
  //v=vMax<I?I:vMax;

  r=(FctVisu)(r);
  g=(FctVisu)(g);
  b=(FctVisu)(b);

  
  *red    =r<seuil_b?0:r>seuil_h?255:(guchar)((r-seuil_b)*t);
  *green  =g<seuil_b?0:g>seuil_h?255:(guchar)((g-seuil_b)*t);
  *blue   =b<seuil_b?0:b>seuil_h?255:(guchar)((b-seuil_b)*t);

  
  return v;
}

/* gdouble calculPixel( _ImVal ImVal,_FctVisu FctVisu, */
/* 		     int x, int y,int xF,int yF,gdouble  vMax, float t, */
/* 		     int  rowstride, int n_channels, guchar *pixels ) */
/* { */
/*   guchar red,green,blue; */
/*   gdouble v=calculRGB( ImVal, FctVisu, */
/* 		       x, y,vMax, t, */
/* 		       &red, &green,&blue ); */

/*   if ((xF<gdk_pixbuf_get_width(pixbuf))&& */
/*       (yF<gdk_pixbuf_get_height(pixbuf))) */
/*     { */
/*       guchar *p; */
/*       p = pixels + yF * rowstride + xF * n_channels; */
/*       p[0] = red; */
/*       p[1] = green; */
/*       p[2] = blue; */
/*       p[3] = 255; */
/*     } */
 

/*   return v; */
/* } */

double cumul=0;

int calculImage(int Xf, int Yf, int Wf, int Hf)
{
  int x,y,i;
  int xF,yF;
  float t;

/*   /\* Chronometer *\/ */
/*   clock_t start, end; */
/*   double elapsed; */
/*   start = clock();	/\* Lancement de la mesure *\/ */


  t=255.0/(seuil_h-seuil_b);
  gdouble vMax=10;

  // Recherche de la fonction de recherche d'une valeur d'un pixel
  _ImVal ImVal  = DefImVal(&im);
  _FctVisu FctVisu  = DefFctVisu();

  if ((Xf>gdk_pixbuf_get_width(pixbuf))||
      (Yf>gdk_pixbuf_get_height(pixbuf))) return ;

  if (Wf>gdk_pixbuf_get_width(pixbuf))   Wf = gdk_pixbuf_get_width(pixbuf);
  if (Hf>gdk_pixbuf_get_height(pixbuf)) Hf = gdk_pixbuf_get_height(pixbuf);


  int X=(int)(Xf*facteur);
  int Y=(int)(Yf*facteur);
  int W=(int)(Wf*facteur);
  int H=(int)(Hf*facteur);
  
  int  rowstride, n_channels;
  guchar *pixels;
  rowstride = gdk_pixbuf_get_rowstride (pixbuf);
  pixels = gdk_pixbuf_get_pixels (pixbuf);
  n_channels = gdk_pixbuf_get_n_channels (pixbuf);

  
  guchar *p;
  //p = pixels + (Yf-1) * rowstride + (Xf-1) * n_channels;
  for (yF=Yf;yF<(Yf+Hf);yF++)
    {
      p = pixels + yF * rowstride + Xf * n_channels;
      for (xF=Xf;xF<(Xf+Wf);xF++)
	{
	  x=(int)(xF*facteur);
	  y=(int)(yF*facteur);
	  /* 	    vMax = calculPixel(ImVal, FctVisu, */
	  /* 			       x,y,xF,yF,vMax,t, */
	  /* 			       rowstride,n_channels,pixels); */
	  
	  guchar red,green,blue;
	  vMax = calculRGB( ImVal, FctVisu,
			    x, y,vMax, t,
			    &red, &green,&blue );
	  
	  /*p = pixels + yF * rowstride + xF * n_channels;*/
	  p[0] = red;
	  p[1] = green;
	  p[2] = blue;
	  p[3] = 255;

	  p += n_channels;
	}
    }
  guchar *p1;
  guchar *p2;

  // carre de la selection
  if (selection.etat==ACTIF)
    {
      int x1,x2,y1,y2;
      
      x1=selection.x1< selection.x2?selection.x1:selection.x2;
      x2=selection.x1< selection.x2?selection.x2:selection.x1;

      y1=selection.y1< selection.y2?selection.y1:selection.y2;
      y2=selection.y1< selection.y2?selection.y2:selection.y1;

      x1=x1>gdk_pixbuf_get_width(pixbuf)? gdk_pixbuf_get_width(pixbuf):x1<0?0:x1;
      x2=x2>gdk_pixbuf_get_width(pixbuf)? gdk_pixbuf_get_width(pixbuf):x2<0?0:x2;
      y1=y1>gdk_pixbuf_get_height(pixbuf)? gdk_pixbuf_get_height(pixbuf):y1<0?0:y1;
      y2=y2>gdk_pixbuf_get_height(pixbuf)? gdk_pixbuf_get_height(pixbuf):y2<0?0:y2;



      p1 = pixels + y1 * rowstride + x1 * n_channels;
      p2 = pixels + y2 * rowstride + x1 * n_channels;
      for(i=x1;i< x2;i++)
	{
	  p1[0] = 255; p1[1]= 255; p1[2]=255; p1[3] = 255;
	  p2[0] = 255; p2[1]= 255; p2[2]=255; p2[3] = 255;
	  p1 = p1 + n_channels;
	  p2 = p2 + n_channels;
	}
      p1 = pixels + y1 * rowstride + x1 * n_channels;
      p2 = pixels + y1 * rowstride + x2 * n_channels;
     
      for(i=y1;i< y2;i++)
	{
	  p1[0] = 255; p1[1]= 255; p1[2]=255; p1[3] = 255;
	  p2[0] = 255; p2[1]= 255; p2[2]=255; p2[3] = 255;
	  p1 = p1 + rowstride;
	  p2 = p2 + rowstride;
	}

 
    }

/*   /\* Chronometer *\/ */
/*   end = clock();		/\* Arret de la mesure *\/ */
/*   elapsed = ((double)end - start) / CLOCKS_PER_SEC; /\* Conversion en seconde *\/ */
/*   cumul += elapsed; */
/*   printf("Temps execution %f %f\n",elapsed,cumul);fflush(stdout); */

  return vMax;
}

void majStatusBar(GtkWidget *widget,gchar *text)
{
  GtkWidget *status;
  status = lookup_widget(GTK_WIDGET(widget), "statusbar1");
  guint context_id;
  
  context_id =gtk_statusbar_get_context_id(GTK_STATUSBAR(status),
					   "apa");
  gtk_statusbar_push(GTK_STATUSBAR(status),
		     context_id, text);
  
  while (gtk_events_pending ())
    gtk_main_iteration ();

}

GtkTreeView *filtres=NULL;
GtkTreeView *treeViewParam=NULL;
GtkWidget *gstfiltres=NULL;
struct parametre ** Parametres=NULL;
int len_Parametres=0;

void appFiltres(GtkWidget *widget)
{
  if (filtres==NULL) return ;

  unsigned long i;
  struct image out ;  
  copyImage(&im, &out);
  for (i=0;i<out.bufferSize;i++)
    out.buffer[i]=im.buffer[i];
  
  int index;
  index=0;

  GModule *module;
  GError **error;
  
  GtkTreeView *treeview;
  treeview = filtres; //lookup_widget(GTK_WIDGET(widget), "filtres");
  GtkTreeModel *tree_model = gtk_tree_view_get_model (treeview);
  GtkTreeIter iter;
  gboolean back;
  back = gtk_tree_model_get_iter_first(tree_model, &iter);
  while (back)
      
  {
    gchar *name;
    gint X,Y,L,H;
    gchar * filename;

    gtk_tree_model_get(tree_model, &iter,
    		       FILTRE_NAME,&name,
		       FILTRE_X,&X,
		       FILTRE_Y,&Y,
		       FILTRE_L,&L,
		       FILTRE_H,&H,	       
		       FILTRE_FILE, &filename,
		       -1);

    //gchar * filename = g_module_build_path (plugins_path,name);
    module = g_module_open (filename, G_MODULE_BIND_LAZY);
    if (module)
      {
	Fonction  fonction;
	
	if (g_module_symbol (module, "Do" , (gpointer *) &fonction))
	  {
	    gchar msg[512];
	    sprintf(msg,"Filtre %s",name);
	    majStatusBar(GTK_WIDGET(widget),msg);

	    fonction(&im,&out,X,Y,L,H,Parametres[index]);
	    for (i=0;i<out.bufferSize;i++)
	      im.buffer[i]=out.buffer[i];
	    	    
	  }
	g_module_close (module);
      }
    
    index++;
    back = gtk_tree_model_iter_next(tree_model, &iter);
    
  }
  free(out.buffer);
}

gdouble creation_pixbuf(GtkWidget *widget)
{
  // Creation pixbuff
  GError **erreur;
  pixbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB,
			  TRUE,
			  8,
			  (int)(im.width/facteur),
			  (int)(im.height/facteur));

  // Redessiner
  gdouble vMax;
  vMax = 20000;
  GtkWidget *image;
  image = lookup_widget(GTK_WIDGET(widget), "image");
  gtk_widget_queue_draw (image);
  gtk_widget_set_size_request (image,
			       gdk_pixbuf_get_width(pixbuf),
			       gdk_pixbuf_get_height(pixbuf));
  
  return vMax;
}
gdouble charge_image(GtkWidget *widget)
{

  gtk_grab_add (widget);

  majStatusBar(GTK_WIDGET(widget),"Chargement image ...");

  gdouble vMax;

  if (pixbuf)
    {
      gdk_pixbuf_unref(pixbuf);
    }

  // Nous allons gerer nous meme l'image tiff
  
  if (im.buffer!=NULL)
    free(im.buffer);

  if (loadTiff(nomImage, &im,A_TRUE)==0)
    {
      gtk_grab_remove (widget);
      majStatusBar(GTK_WIDGET(widget),"" );
      return 0;
    }
      
  // Application des filtres sur l'image
  
  appFiltres(widget);
  
  // Nom de l'image dans la barre des titres
  GtkWidget *wid;
  wid = lookup_widget(GTK_WIDGET(widget), "princ");
  char *s = malloc(sizeof(char)*(strlen(nomImage)+10));
  sprintf(s,"APA : %s",nomImage);
  gtk_window_set_title (GTK_WINDOW (wid),s); 
  free(s);

  vMax = creation_pixbuf(widget);

  majStatusBar(GTK_WIDGET(widget),"Ok");
  gtk_grab_remove (widget);
  return vMax;

}

gdouble save_image(GtkWidget *widget,gchar * fichier, gint rep)
{
  if (rep == GTK_RESPONSE_NO)
    {
      printf ("16 bits\n");
      writeTiff(&im,(char *) fichier);
    }
  else
    {
      printf ("8 bits\n");
      copy16to8IF(&im,(char *) fichier,(int)seuil_b,(int)seuil_h);
    }
}

void trtZoom(GtkWidget *widget)
{
/*   GtkWidget *scrolledwindow; */
/*   scrolledwindow = lookup_widget(GTK_WIDGET(widget), "scrolledwindow1"); */

/*   gdouble width; */
/*   gdouble height; */
  
/*   GtkAdjustment * adjustment; */
/*   adjustment = gtk_scrolled_window_get_hadjustment(GTK_SCROLLED_WINDOW(scrolledwindow)); */
/*   height = gtk_adjustment_get_value (adjustment); */

/*   adjustment = gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(scrolledwindow)); */
/*   width = gtk_adjustment_get_value (adjustment); */

/*   printf("%dx%d %d %d\n",width,height, */
/* 	 adjustment->upper, */
/* 	 width / adjustment->upper );fflush(stdout); */
  

  GtkWidget *image;
  selection.etat=INACTIF;
  image = lookup_widget(GTK_WIDGET(widget), "image");
  creation_pixbuf(widget);
  //on_image_realize (image,NULL);
  gtk_widget_queue_draw (image);
}
// Fin APA

void
on_nouveau1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}



void
on_enregistrer1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_couper1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copier1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  // Image vers le presse papier
  // Presse papier
  GtkClipboard *clipboard; // LE presse papier
  clipboard = gtk_clipboard_get(gdk_atom_intern("CLIPBOARD",FALSE)); // Je rcupre le presse papier principal (celui que l'on utilise normalement)
  
  gtk_clipboard_set_image (clipboard,
			   pixbuf);
  gtk_clipboard_store(clipboard);
  
}


void
on_coller1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_supprimer1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  
  GtkWidget *about;
  about = create_about ();
  gtk_widget_show (about);

}


gboolean
on_image_configure_event               (GtkWidget       *widget,
                                        GdkEventConfigure *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_image_expose_event                  (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{

  calculImage(event->area.x, event->area.y,event->area.width, event->area.height); 

  gdk_draw_pixbuf(widget->window,
                  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
                  pixbuf,
                  0, 0,
                  0,0,
		  gdk_pixbuf_get_width(pixbuf),
		  gdk_pixbuf_get_height(pixbuf),
		  GDK_RGB_DITHER_NONE,0,0);

  return FALSE;
}

void initialise_image (GtkWidget       *widget)
{

  gdouble vMax;
  vMax = charge_image(widget);
  
  GtkWidget *range;
  range = lookup_widget(GTK_WIDGET(widget), "seuil_h");
  gtk_range_set_range(GTK_RANGE(range),
		      0,
		      vMax);
  gtk_range_set_value(GTK_RANGE(range),
		      (gint)seuil_h);
  range = lookup_widget(GTK_WIDGET(widget), "seuil_b");
  gtk_range_set_range(GTK_RANGE(range),
		      0,
		      vMax);
  gtk_range_set_value(GTK_RANGE(range),
		      (gint)seuil_b);
  range = lookup_widget(GTK_WIDGET(widget), "seuil_f");
  gtk_range_set_range(GTK_RANGE(range),
		      0,
		      vMax);
  gtk_range_set_value(GTK_RANGE(range),
		      (gint)seuil_f);

  
  //Initialisation de la structure selection
  selection.etat=INACTIF;
  selection.x1=-1;
  selection.y1=-1;
  selection.x2=-1;
  selection.y2=-1;

  // Domain des seuils
  GString *s;
  s = g_string_new ("");
  g_string_printf(s,"%i",(int)vMax);
  range = lookup_widget(GTK_WIDGET(widget), "seuil_h_max");
  gtk_entry_set_text (GTK_ENTRY(range), s->str);
  
  
}

void
on_image_realize                       (GtkWidget       *widget,
                                        gpointer         user_data)
{

  
  if (nomImage==NULL)
    {
      nomImage=malloc(sizeof(gchar)*100);
      sprintf(nomImage,"%s","fin.tiff");
    }
  im.buffer=NULL;
  
  initialise_image (widget);
  on_gstfiltres_realize(widget,user_data);
  
}



void
on_seuil_h_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
  //gint iValue;
  
  /* Recuperation de la valeur de la scrollbar */
  seuil_h = gtk_range_get_value(GTK_RANGE(range));
  GtkWidget *widget;
  widget = lookup_widget(GTK_WIDGET(range), "image");
  gtk_widget_queue_draw (widget);
}


void
on_seuil_b_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
  seuil_b = gtk_range_get_value(GTK_RANGE(range));
  GtkWidget *widget;
  widget = lookup_widget(GTK_WIDGET(range), "image");
  gtk_widget_queue_draw (widget);
  if (seuil_f <seuil_b)
    {
      widget = lookup_widget(GTK_WIDGET(range), "seuil_f");
      gtk_range_set_value(GTK_RANGE(widget),(gint)seuil_b);
    }

}


void
on_seuil_f_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
  seuil_f = gtk_range_get_value(GTK_RANGE(range));
  GtkWidget *widget;
  widget = lookup_widget(GTK_WIDGET(range), "image");
  gtk_widget_queue_draw (widget);
}

void
openFichier                         (GtkWidget   *toolbutton,
				     gpointer         user_data)
{
  GtkWidget * FileChooser;
  GtkWidget *princ;
  princ = lookup_widget(GTK_WIDGET(toolbutton), "princ");
  FileChooser = gtk_file_chooser_dialog_new("APA Choix d'un fichier",
					    GTK_WINDOW(princ),
					    GTK_FILE_CHOOSER_ACTION_OPEN,
					    GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
					    GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
					    NULL);

  GtkFileFilter *filter = gtk_file_filter_new ();
  gtk_file_filter_set_name (filter,"Fichier Tiff");
  gtk_file_filter_add_pattern (filter, "*.tiff");
  gtk_file_filter_add_pattern (filter, "*.tif");
  gtk_file_filter_add_pattern (filter, "*.TIFF");
  gtk_file_filter_add_pattern (filter, "*.TIF");

  gtk_file_chooser_add_filter(GTK_FILE_CHOOSER (FileChooser),
			      filter);

  if (gtk_dialog_run (GTK_DIALOG (FileChooser)) == GTK_RESPONSE_ACCEPT)
    {
      
      
      nomImage = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (FileChooser));
      initialise_image (GTK_WIDGET(toolbutton));
      
    }
  gtk_widget_destroy (FileChooser);

}

void
on_ouvrir1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 openFichier (GTK_WIDGET(menuitem), user_data);
}

void
on_open_clicked                        (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  openFichier(GTK_WIDGET(toolbutton),user_data);
}

void
on_save_clicked                        (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{

}

void
saveas                      (GtkWidget   *toolbutton,
			     gpointer         user_data)
{

  GtkWidget * FileChooser;
  GtkWidget *princ;
  princ = lookup_widget(GTK_WIDGET(toolbutton), "princ");
  FileChooser = gtk_file_chooser_dialog_new("APA Enregistrer le fichier sous",
					    GTK_WINDOW(princ),
					    GTK_FILE_CHOOSER_ACTION_SAVE,
					    GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
					    GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT,
					    NULL);

  gtk_file_chooser_set_do_overwrite_confirmation (GTK_FILE_CHOOSER (FileChooser), TRUE);

  /*   if (user_edited_a_new_document)  */
  /*     { */
  /*       gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (FileChooser), default_folder_for_saving); */
  gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (FileChooser), "titre.tiff");
  /*     } */
  /*   else */
  /*     gtk_file_chooser_set_filename (GTK_FILE_CHOOSER (FileChooser), filename_for_existing_document); */
  
  GtkFileFilter *filter = gtk_file_filter_new ();
  gtk_file_filter_set_name (filter,"Fichier Tiff");
  gtk_file_filter_add_pattern (filter, "*.tiff");
  gtk_file_filter_add_pattern (filter, "*.tif");
  gtk_file_filter_add_pattern (filter, "*.TIFF");
  gtk_file_filter_add_pattern (filter, "*.TIF");

  gtk_file_chooser_add_filter(GTK_FILE_CHOOSER (FileChooser),
			      filter);

  if (gtk_dialog_run (GTK_DIALOG (FileChooser)) == GTK_RESPONSE_ACCEPT)
    {

      char *filename; 
      filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (FileChooser));
      printf("Save %s\n",filename);

      GtkWidget *pQuestion;

      /* Creation de la boite de message */
      /* Type : Question -> GTK_MESSAGE_QUESTION */
      /* Boutons : 1 OUI, 1 NON -> GTK_BUTTONS_YES_NO */
      pQuestion = gtk_message_dialog_new (GTK_WINDOW(princ),
					  GTK_DIALOG_MODAL,
					  GTK_MESSAGE_QUESTION,
					  GTK_BUTTONS_YES_NO,
					  "Voulez-vous convertir de 16 bits vers 8 bits ? ");
      /* Affichage et attente d une reponse */
      gint rep = gtk_dialog_run(GTK_DIALOG(pQuestion));

      gtk_widget_destroy(pQuestion);
      gtk_widget_queue_draw (princ);

      save_image(GTK_WIDGET(toolbutton),filename,rep);
      g_free (filename);
    }
  gtk_widget_destroy (FileChooser);
  
}

void
on_enregistrer_sous1_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  saveas(GTK_WIDGET(menuitem), user_data);
}


void
on_saveas_clicked                      (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  saveas(GTK_WIDGET(toolbutton),user_data);
}

void
on_zoomIn_clicked                      (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  facteur = facteur / 1.5;
  trtZoom(GTK_WIDGET(toolbutton));
}


void
on_zoomOut_clicked                     (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  facteur = facteur * 1.5;
  trtZoom(GTK_WIDGET(toolbutton));
}


void
on_zomm100_clicked                     (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  facteur=1;
  trtZoom(GTK_WIDGET(toolbutton));
}

void
on_zoomAuMieux_clicked                 (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{

/*   GtkWidget *widget; */
/*   widget = lookup_widget(GTK_WIDGET(toolbutton), "viewport1"); */
/*   gdouble width; */
/*   gdouble height; */
/*   //gtk_widget_get_size         (widget,&width,&height); */

/*   GtkAdjustment * adjustment; */
/*   adjustment = gtk_viewport_get_hadjustment(GTK_VIEWPORT(widget)); */
/*   height = gtk_adjustment_get_value (adjustment);   */
/*   adjustment = gtk_viewport_get_vadjustment(GTK_VIEWPORT(widget)); */
/*   width = gtk_adjustment_get_value (adjustment);  */
/*   printf("%dx%d\n",width,height);fflush(stdout); */
  
  if ((vp_l!=0)&&(vp_h!=0))
    {
      float a,b;
     /*  a=(float)vp_l/im.width; */
      /*       b=(float)vp_h/im.height; */
      a=(float)im.width/vp_l;
      b=(float)im.height/vp_h;
      if (a<b) facteur=a;
      else facteur=b;
      trtZoom(GTK_WIDGET(toolbutton));
    }

}


gboolean
on_viewport1_motion_notify_event       (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
  int x, y;
  GdkModifierType state;
  
  if (event->is_hint)
    gdk_window_get_pointer (event->window, &x, &y, &state);
  else
    {
      x = event->x;
      y = event->y;
      state = event->state;
    }
  
  if (((event->state & GDK_BUTTON1_MASK)  == GDK_BUTTON1_MASK)&&
      ( selection.etat==ACTIF))
    {
      selection.x2=event->x;
      selection.y2=event->y;
      GtkWidget *image;
      image = lookup_widget(GTK_WIDGET(widget), "image");
      gtk_widget_queue_draw (image);
      
    }
  
  gchar info[512];
  
  x=(int)(x*facteur);
  y=(int)(y*facteur);
  
  if ((x>=0)&&(x<im.width)&&(y>=0)&&(y<im.height))
    {
      
      int R,G,B,I;
      unsigned long count;
      count = y*im.width+ x;
      if (im.sampleParPixel==3)
	{
	  if (im.bps==16)
	    {
	      R=im.buffer[count*6  ]+256*im.buffer[count*6+1];
	      G=im.buffer[count*6+2]+256*im.buffer[count*6+3];
	      B=im.buffer[count*6+4]+256*im.buffer[count*6+5];
	      
	    }
	  else
	    {
	      R=im.buffer[count*3  ];
	      G=im.buffer[count*3+1];
	      B=im.buffer[count*3+2];
	    }
	  sprintf(info,"(%i,%i) R=%i G=%i B=%i",x,y,R,G,B);
	}
      else
	{
	  if (im.bps==16)
	    I=im.buffer[count*2]+256*im.buffer[count*2+1];
	  else
	    I=im.buffer[count];
	  sprintf(info,"(%i,%i) I=%i",x,y,I);
	}
      
      
      GtkLabel *infoXY;
      infoXY = (GtkLabel *) lookup_widget(GTK_WIDGET(widget), "infoXY");
      gtk_label_set_text(infoXY,info);
      
    }     
  return TRUE;
}
  

void
on_viewport1_size_allocate             (GtkWidget       *widget,
                                        GdkRectangle    *allocation,
                                        gpointer         user_data)
{
  vp_l=allocation->width;
  vp_h=allocation->height;

}


gboolean
on_viewport1_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  if (event->type == GDK_BUTTON_PRESS)
    {
      selection.etat=ACTIF;
      selection.x1=event->x;
      selection.y1=event->y;
      selection.x2=event->x;
      selection.y2=event->y; 
    }
  return FALSE;
}


gboolean
on_viewport1_button_release_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  
  if (event->type == GDK_BUTTON_RELEASE)
    {

      // selection.etat=INACTIF;
      selection.x2=event->x;
      selection.y2=event->y;
    }
  return FALSE;
}


gboolean
on_viewport1_key_press_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  //guint modifiers;
  //modifiers = gtk_accelerator_get_default_mod_mask ();
 
  GdkDisplay *display = NULL;
  GdkScreen *screen = NULL; 

  gint x=0, y=0, xadd=0, yadd=0; 
  int vRet = FALSE;
  switch (event->keyval)
    {
    case GDK_Left:
      //g_print ("A gauche\n");
      xadd -= 1; 
      vRet = TRUE;
      break;
    case GDK_Right:
      //g_print ("A droite\n");
      xadd += 1; 
      vRet = TRUE;
      break;
    case GDK_Up   :
      //g_print ("A haut\n");
      yadd -= 1; 
      vRet = TRUE;
      break;
    case GDK_Down   :
      yadd += 1; 
      //g_print ("A bas \n");
      vRet = TRUE;
      break;
    default:
      return FALSE; /* propogate event */ 
    }
  
     /* get default display and screen */
    display = gdk_display_get_default ();
    screen = gdk_display_get_default_screen (display);
   
    /* get cursor position */
    gdk_display_get_pointer (display, NULL, &x, &y, NULL);
   
    /* set new cusor position */
    x += xadd;
    y += yadd;
    gdk_display_warp_pointer (display, screen, x, y); 

  return vRet;
}


gboolean
on_viewport1_key_release_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_about_response                      (GtkDialog       *dialog,
                                        gint             response_id,
                                        gpointer         user_data)
{
  printf("about2");
  gtk_widget_hide (GTK_WIDGET(dialog));
}


void
on_Reload_clicked                      (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  charge_image(GTK_WIDGET(toolbutton));
}


gboolean
on_gstfiltres_expose_event             (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_gstfiltres_realize                  (GtkWidget       *widget,
                                        gpointer         user_data)
{
  // Liste des plugins disponible
  GModule*module;
  GError **error;
  A_Name name;
  A_Init init;
  A_Version version;
   
  GtkWidget *treeview;
  //GtkTreeModel *model;
  GtkCellRenderer *renderer;
  GtkTreeViewColumn *column;

  treeview = lookup_widget(GTK_WIDGET(widget), "disponible");
  

  GtkListStore *store;
  GtkTreeIter iter;
  
  GSList *liste = NULL;

  /* create list store */
  store = gtk_list_store_new (NUM_COLUMNS,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING
			      );
  gtk_tree_view_set_model(GTK_TREE_VIEW(treeview),GTK_TREE_MODEL (store));
  // Lecture des filtres disponibles
  if (!g_module_supported())
    {
      printf ("Plugins non supports\n");
      exit(1);
    }
  
  GError *  p_error = NULL;
  GDir *dir = g_dir_open (plugins_path, 0,&p_error);

  if (!dir)
    {
      g_printf ("Erreur : %s\n", p_error->message);
      g_error_free (p_error);
    }
  else
    
    {
      const gchar *nomFiltre = NULL;
      while (nomFiltre = g_dir_read_name (dir))
	{
	  gchar * filename = g_module_build_path (plugins_path,nomFiltre);
	  module = g_module_open (filename, G_MODULE_BIND_LAZY);
	  if (module)
	    {
	      Fonction  fonction;
	     

	      if (g_module_symbol (module, "Version" , (gpointer *) &version))
		{
		  gdouble val=g_ascii_strtod(version(),NULL);
		  if (val>=API_VERSION)
		    
		    if (g_module_symbol (module, "Name" , (gpointer *) &name))
		      {
			struct filtre *f;
			f=name();
			printf("%s avec %s\n",filename,f->name);
/* 			// Ajout de la ligne */
			
/* 			gtk_list_store_append (store, &iter); */
/* 			gtk_list_store_set (store, &iter, */
/* 					    COLUMN_NAME,(gchar *)f->name, */
/* 					    COLUMN_DESCRIPTION,f->desc, */
/* 					    COLUMN_FILE,filename, */
/* 					    -1); */
 			
			
 			// Recherche existance 
			
 			GSList *back=NULL;
 			gboolean find;
 			find = FALSE;
 			back = liste;
 			while (back!=NULL)
 			  {
 			    gchar *nom;
 			    if (g_ascii_strcasecmp(back->data,f->name)==0)
 			      find = TRUE;
			    
 			    back = g_slist_next(back);
			    
 			  }
			
 			if (!find) {
 			  liste = g_slist_append(liste, g_strdup_printf("%s",f->name));
 			  // Ajout de la ligne
			  
 			  printf("%s avec %s\n",filename,f->name);
 			  gtk_list_store_append (store, &iter);
 			  gtk_list_store_set (store, &iter,
 					      COLUMN_NAME,(gchar *)f->name,
 					      COLUMN_DESCRIPTION,f->desc,
 					      COLUMN_FILE,filename,
 					      -1);
			  
			}
		      }
		  g_module_close (module);
		}
	    }
	}
      fflush(stdout);
      gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treeview), TRUE);
      gtk_tree_view_set_search_column (GTK_TREE_VIEW (treeview),
				       0);
      
      
 

      renderer = gtk_cell_renderer_text_new ();
      
      column = gtk_tree_view_column_new_with_attributes ("Filtre disponible",
							 renderer,
							 "text",COLUMN_NAME,
							 NULL);
      gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
      renderer = gtk_cell_renderer_text_new ();
      
      column = gtk_tree_view_column_new_with_attributes ("Description",
							 renderer,
							 "text",COLUMN_DESCRIPTION,
							 NULL);
      gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
      
    }

  // Liste des filtres a appliquer
  treeview = lookup_widget(GTK_WIDGET(widget), "filtres");
  filtres = (GtkTreeView *)treeview ; 
  /* create list store */
  store = gtk_list_store_new (FILTRE_NUM_COLUMNS,
			      G_TYPE_BOOLEAN,
			      G_TYPE_STRING,
			      G_TYPE_UINT,
			      G_TYPE_UINT,
			      G_TYPE_UINT,
			      G_TYPE_UINT,
			      G_TYPE_STRING
			      );
  gtk_tree_view_set_model(GTK_TREE_VIEW(treeview),GTK_TREE_MODEL (store));

  // Description des colonnes
  renderer = gtk_cell_renderer_toggle_new ();
  column = gtk_tree_view_column_new_with_attributes ("Actif",
						     renderer,
						     "active", FILTRE_TOGGLE,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
  
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("Nom",
						     renderer,
						     "text",FILTRE_NAME,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);

  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("X",
						     renderer,
						     "text",FILTRE_X,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
      
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("Y",
						     renderer,
						     "text",FILTRE_Y,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
  
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("L",
						     renderer,
						     "text",FILTRE_L,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
  
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("H",
						     renderer,
						     "text",FILTRE_H,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);  

  // Liste des parametres d'un filtre
  treeview = lookup_widget(GTK_WIDGET(widget), "param");
  treeViewParam = (GtkTreeView *)treeview;
  /* create list store */
  store = gtk_list_store_new (PARAM_NUM_COLUMNS,
			      G_TYPE_STRING,
			      G_TYPE_STRING,
			      G_TYPE_STRING
			      );
  gtk_tree_view_set_model(GTK_TREE_VIEW(treeview),GTK_TREE_MODEL (store));

  // Description des colonnes
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("Parametre",
						     renderer,
						     "text",PARAM_NAME,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);

  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("Description",
						     renderer,
						     "text",PARAM_DESC,
						     NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);
  renderer = gtk_cell_renderer_text_new ();
  column = gtk_tree_view_column_new_with_attributes ("Valeur",
						     renderer,
						     "text",PARAM_VALEUR,
						     NULL);
  g_object_set(renderer, "editable", TRUE, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), column);

  g_signal_connect ((gpointer) renderer, "edited",
                    G_CALLBACK (on_param_valeur_changed),
                    NULL); // a supprimer PARAM_VALEUR);
  gtk_tree_selection_set_select_function(gtk_tree_view_get_selection(GTK_TREE_VIEW(filtres)),
					 filtres_selection_func,
					 "",
					 NULL);

}

void
on_FiltreAdd_clicked                   (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  GtkTreeIter iter;
  GtkTreeView *treeview;
  GtkListStore *store;
  treeview = (GtkTreeView *)lookup_widget(GTK_WIDGET(toolbutton),
					  "disponible");
  GtkTreeModel *model = gtk_tree_view_get_model (treeview);
  GtkTreeSelection *select = gtk_tree_view_get_selection (treeview);
  if (gtk_tree_selection_get_selected (select, NULL, &iter))
    {
      gint i;
      GtkTreePath *path;

      path = gtk_tree_model_get_path (model, &iter);
      i = gtk_tree_path_get_indices (path)[0];
      
      gchar *name;
      gtk_tree_model_get(model, &iter,
			 COLUMN_NAME,&name,
			 -1);
      gchar *file;
      gtk_tree_model_get(model, &iter,
			 COLUMN_FILE,&file,
			 -1);
      
      GtkTreeIter f_iter;
      GtkTreeView *f_treeview;
      f_treeview = (GtkTreeView *)lookup_widget(GTK_WIDGET(toolbutton),
						"filtres");
      store = (GtkListStore *)gtk_tree_view_get_model(f_treeview);

      guint X,Y,L,H;
      if (selection.etat==ACTIF)
	{
	  X=selection.x1<selection.x2?selection.x1*facteur
	    :selection.x2*facteur;
	  Y=selection.y1<selection.y2?selection.y1*facteur
	    :selection.y2*facteur;
	  L=abs(selection.x2*facteur-selection.x1*facteur);
	  H=abs(selection.y2*facteur-selection.y1*facteur);
	  if ((X+L)>im.width) L=im.width-X;
	  if ((Y+H)>im.height) L=im.height-Y;
	}
      else
	{
	  X=0;
	  Y=0;
	  L=im.width;
	  H=im.height;
	}
      gtk_list_store_append (store, &f_iter);
      gtk_list_store_set (store, &f_iter,
			  FILTRE_TOGGLE,TRUE,
			  FILTRE_NAME,name,
			  FILTRE_X,X,
			  FILTRE_Y,Y,
			  FILTRE_L,L,
			  FILTRE_H,H,
			  FILTRE_FILE,file,
			  -1);
      gtk_tree_path_free (path);

      len_Parametres +=1;
      Parametres = realloc(Parametres,
			   sizeof(struct parametre *)*len_Parametres);
      Parametres[len_Parametres-1]=NULL;
      // On charge la structure des parametres dans le module

      GModule*module;
      GError **error;
  
      gchar * filename = file; //g_module_build_path (plugins_path,name);
      module = g_module_open (filename, G_MODULE_BIND_LAZY);
      if (module)
	{
	  InitParam  initParam;
	  
	  if (g_module_symbol (module, "Init" , (gpointer *) &initParam))
	    {
	      struct parametre * temp;
	      struct parametre * pt;
	      struct parametre * p;
	      temp = initParam();
	      Parametres[len_Parametres-1] = NULL;
	      pt = NULL;
	      printf(" %i %i\n",Parametres[len_Parametres-1],pt);
	      // On recopie en mmoire les parametres
	      while (temp!=NULL)
		{
		  printf("param %s\n",temp->name);
	 	  p = malloc(sizeof(struct parametre)); 
		  p->name=g_strdup_printf(temp->name);
		  p->desc=g_strdup_printf(temp->desc);
		  p->type=temp->type;
		  p->intvalue=temp->intvalue;
		  p->floatvalue=temp->floatvalue;
		  p->next=NULL;
		  if (pt==NULL)  
  		    {
		      pt=p;   
		      Parametres[len_Parametres-1]=p;
		    }
 		  else 
		    {
		      pt->next=p; 
		      pt=p; 
		    }
		  temp=temp->next;
		
		}
	      //Parametres[len_Parametres-1]=
	      //struct parametre * p;

	      //p=temp

	      //pppppp
		
	      fflush(stdout);
	    }
	  g_module_close (module);
	}


    }
}

void
on_FiltreSupp_clicked                  (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{

  GtkTreeIter iter;
  GtkTreeView *treeview;
  treeview = (GtkTreeView *)lookup_widget(GTK_WIDGET(toolbutton), "filtres");
  GtkTreeModel *model = gtk_tree_view_get_model (treeview);
  GtkTreeSelection *select = gtk_tree_view_get_selection (treeview);

  if (gtk_tree_selection_get_selected (select, NULL, &iter))
    {
      gint i;
      GtkTreePath *path;

      path = gtk_tree_model_get_path (model, &iter);
      i = gtk_tree_path_get_indices (path)[0];
      gtk_list_store_remove (GTK_LIST_STORE (model), &iter);
      printf("Indice %i\n",i);fflush(stdout);

      GtkListStore *store;
      store = (GtkListStore *)gtk_tree_view_get_model(treeViewParam);
      gtk_list_store_clear(store);

      // Lecture des parametres

      if (len_Parametres <=1)
	{
	  free(Parametres);
	  Parametres=NULL;
	  len_Parametres=0;
	}
      else
	{
	  struct parametre ** ParametresTmp;
	  len_Parametres -=1;
	  ParametresTmp = malloc(sizeof(struct parametre *)*len_Parametres);
	  int j,k;
	  k=0;
	  for (j=0;j<=len_Parametres;j++)
	    if (i!=j)
	      {
		// On recopie sauf l'indice a enlever
		ParametresTmp[k]=Parametres[j];
		k++;
	      }
	  free(Parametres);
	  Parametres = ParametresTmp;

	}
      gtk_tree_path_free (path);
    }
  
}


void
on_seuil_h_max_changed            (GtkEditable     *editable,
				   gpointer         user_data)
{

 // Domain des seuils
  const gchar *s;
  s=gtk_entry_get_text (GTK_ENTRY(editable));
  gdouble vmax = g_strtod(s,NULL);
  if ((vmax>0)&&(vmax<=65535))
    {
      GtkWidget *range;
      range = lookup_widget(GTK_WIDGET(editable), "seuil_h");
      gtk_range_set_range(GTK_RANGE(range),
			  0,
			  vmax);
      range = lookup_widget(GTK_WIDGET(editable), "seuil_b");
      gtk_range_set_range(GTK_RANGE(range),
			  0,
			  vmax);
      range = lookup_widget(GTK_WIDGET(editable), "seuil_f");
      gtk_range_set_range(GTK_RANGE(range),
			  0,
			  vmax);
    }

}



gboolean
filtres_selection_func (GtkTreeSelection *selection,
			GtkTreeModel     *model,
			GtkTreePath      *path,
			gboolean          path_currently_selected,
			gpointer          userdata)
{
  GtkTreeIter iter;
  int index;

  if (gtk_tree_model_get_iter(model, &iter, path)
      &&!path_currently_selected)
  {

    // Index of the row that is being selected/deselected
    index = (gtk_tree_path_get_indices(path))[0]; // or maybe you dont care about the int index??
    // you could also get the text instead...

    gchar *name;
    gtk_tree_model_get_iter(model, &iter, path);
    
    gtk_tree_model_get(model, &iter,
		       FILTRE_NAME,&name,
		       -1);
    printf("Name = %s etat %i %s\n",name,path_currently_selected,userdata);
    fflush(stdout);
  
    // Liste des paramtres du filtre selectionne
    GtkListStore *store;
    GtkTreeIter f_iter;
    GtkTreeView *f_treeview;
    f_treeview = (GtkTreeView *)( lookup_widget(GTK_WIDGET(filtres), "param"));
    store = (GtkListStore *)(gtk_tree_view_get_model(f_treeview));
    
    gtk_list_store_clear(store);

    int j;
    printf("index %i\n",index);fflush(stdout);
    // Recherche des parametres dans la liste	
    for (j=0;j<len_Parametres;j++)
      if (j==index)
	{
	  struct parametre * p;
	  p=Parametres[j];
	  while (p!=NULL)
	    {
	      printf("p %i  \n",p);fflush(stdout);
	      //printf("p %i %i %s \n",p,p->next);fflush(stdout);
	      gtk_list_store_append (store, &f_iter);
	      gchar *val;
	      val = ConvParamChar(p);
	      gtk_list_store_set (store, &f_iter,
				  PARAM_NAME,p->name,
				  PARAM_DESC,p->desc,
				  PARAM_VALEUR,val,
				  -1);
	      p=p->next;
	    }
	}
    
  }
  
  return TRUE; /* allow selection state to change */
  
}


void  on_param_valeur_changed (GtkCellRendererText *renderer,
			       gchar *path_string,
			       gchar *new_text,
			       gpointer user_data)
{
  printf("Text %s\n", new_text);
  fflush(stdout);

  GtkTreeIter iter;
  int index;
  GtkTreeModel *tree_model = gtk_tree_view_get_model (filtres);
  GtkTreeSelection *selection = gtk_tree_view_get_selection (filtres);
  if (gtk_tree_selection_get_selected (selection, 
				       NULL, //tree_model,
				       &iter))
    {
      GtkTreePath *path;
      path = gtk_tree_model_get_path (tree_model, &iter);
      index = (gtk_tree_path_get_indices(path))[0];
      printf("index %i",index);fflush(stdout);
      
      GtkTreeIter iter_p;
      GtkTreeModel *tree_model_p = gtk_tree_view_get_model (treeViewParam);
      printf("path string %s\n",path_string);fflush(stdout);
      if (gtk_tree_model_get_iter_from_string (tree_model_p, &iter_p, path_string))
	{
	}

      int index2;
      index2 = atoi(path_string);
	  
      //for (j=0;j<len_Parametres;j++)
      //	if (j==index)
      //	  {
      struct parametre * p;
      p=Parametres[index];
      gint j;
      j=0;
      while (p!=NULL)
	{
	  if (j==index2)
	    {
	      ConvCharParam(p,new_text);
	      gchar *val;
	      val = ConvParamChar(p);
	      
	      printf("the p %i %i %s %s %i\n",p,p->next,val,
		     p->name,
		     p->intvalue);fflush(stdout);
	      GtkListStore *store;
	      store = (GtkListStore *)gtk_tree_view_get_model(treeViewParam);
	      gtk_list_store_set (store, &iter_p,
				  PARAM_VALEUR,val,
				  -1);
	    }
	  j++;
	  p=p->next;
	}
    }
  
  
}

void
on_stat_clicked                        (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{

  if (selection.etat==ACTIF)
    {
      int X,Y,L,H;
      X=selection.x1*facteur;
      Y=selection.y1*facteur;
      L=selection.x2*facteur-selection.x1*facteur;
      H=selection.y2*facteur-selection.y1*facteur;

      double mR,mG,mB;
      double m2R,m2G,m2B;
      int32 nbVal,R,G,B;
      int x,y;
      mR=0;
      mG=0;
      mB=0;
      m2R=0;
      m2G=0;
      m2B=0;
      nbVal=0;
      for (y=Y;y<(Y+H);y++)
	for (x=X;x<(X+L);x++)
	  {
    
	    unsigned long count;
	    count = y*im.width+ x;
	    if (im.sampleParPixel==3)
	      if (im.bps==16)
		{
		  R=im.buffer[count*6  ]+256*im.buffer[count*6+1];
		  G=im.buffer[count*6+2]+256*im.buffer[count*6+3];
		  B=im.buffer[count*6+4]+256*im.buffer[count*6+5];
		}
	      else
		{
		  R=im.buffer[count*3  ];
		  G=im.buffer[count*3+1];
		  B=im.buffer[count*3+2];
		}
	    else
	      {
		if (im.bps==16)
		  {
		    R=im.buffer[count*2]+256*im.buffer[count*2+1];
		    G=im.buffer[count*2]+256*im.buffer[count*2+1];
		    B=im.buffer[count*2]+256*im.buffer[count*2+1];
		  }
		else
		  {
		    R=im.buffer[count];
		    G=im.buffer[count];
		    B=im.buffer[count];
		  }
	      }
	    mR+=R;
	    mG+=G;
	    mB+=B;
	    m2R+=R*R;
	    m2G+=G*G;
	    m2B+=B*B;
	    nbVal++;
	  }
      mR = nbVal!=0?mR/nbVal:mR;
      mG = nbVal!=0?mG/nbVal:mG;
      mB = nbVal!=0?mB/nbVal:mB;
      m2R = nbVal!=0?m2R/nbVal:m2R;
      m2G = nbVal!=0?m2G/nbVal:m2G;
      m2B = nbVal!=0?m2B/nbVal:m2B;
      gchar text[512];
      if (im.sampleParPixel==3)
	sprintf(text,"Moyenne sur la selection R=%i G=%i B=%i Ecarts type eR=%i eG=%i eB=%i",
		(int)mR,(int)mG,(int)mB,
		(int)sqrt(m2R-mR*mR),(int)sqrt(m2G-mG*mG),(int)sqrt(m2B-mB*mB));
      else
	sprintf(text,"Moyenne sur la selection I=%i Ecarts type %i",
		(int)mR,(int)sqrt(m2R-mR*mR));
      majStatusBar(GTK_WIDGET(toolbutton),text);
      

    }
}

GKeyFile * lectureIniFile()
{
  // Lecture du fichier de config
  
  GKeyFile *  p_key_file;
  p_key_file = g_key_file_new ();
  
  GError *  p_error = NULL;
  gchar text[512];
  sprintf(text,"%s/.apa.ini",getenv("HOME"));
  
  if (! g_key_file_load_from_file (
				   p_key_file,
				   text,
				   G_KEY_FILE_KEEP_COMMENTS,
				   &p_error))
    if (! g_key_file_load_from_file (
				     p_key_file,
				     PACKAGE_DATA_DIR "/" PACKAGE "/apa.ini",
				     G_KEY_FILE_KEEP_COMMENTS,
				     &p_error))
      if (! g_key_file_load_from_file (
				       p_key_file,
				       "apa.ini",
				       G_KEY_FILE_KEEP_COMMENTS,
				       &p_error))
	
	{
	  /* Error, exit program. */
	  g_warning ("Impossible to load config file : %s\n", p_error->message);
	  g_error_free (p_error);
	  
	  exit (EXIT_FAILURE);
	}
/*       else printf("\napa.ini dans .\n"); */
/*     else printf("\napa.ini dans " PACKAGE_DATA_DIR "/" PACKAGE "/apa.ini\n" ); */
/*   else printf("\napa.ini dans %s\n",text); */

  return p_key_file;
}

void
on_princ_realize                       (GtkWidget       *widget,
                                        gpointer         user_data)
{
  
  // Chargement des options par defaut
  GKeyFile * p_key_file = lectureIniFile();
  // Le repertoire des plugins
  plugins_path  = g_key_file_get_string (p_key_file, "APA-TRT", "path", NULL);
  if (plugins_path==NULL)  plugins_path  = ".";

  GtkWidget *window;
  window = lookup_widget(GTK_WIDGET(widget), "princ");

  gtk_window_move(GTK_WINDOW(window),
		  g_key_file_get_integer (p_key_file,
					  "APA-GUI",
					  "x", NULL),
		  g_key_file_get_integer (p_key_file,
					  "APA-GUI",
					  "y", NULL));

  gtk_window_set_default_size(GTK_WINDOW(window),
			      g_key_file_get_integer (p_key_file,
						      "APA-GUI",
						      "width", NULL),
			      g_key_file_get_integer (p_key_file,
						      "APA-GUI",
						      "height", NULL));
  GtkWidget *WorkPath;
  WorkPath = lookup_widget(GTK_WIDGET(widget), "WorkPath");
  gchar * s = g_key_file_get_string (p_key_file,
				     "APA-GUI",
				     "workingpath", NULL);
  if (s==NULL)
    gtk_entry_set_text (GTK_ENTRY(WorkPath),getenv("HOME"));
  else
    gtk_entry_set_text (GTK_ENTRY(WorkPath),s);

  GtkWidget *wid = lookup_widget(GTK_WIDGET(widget), "vpaned2");
  gint pos = g_key_file_get_integer (p_key_file, "APA-GUI", "vpaned2", NULL);
  if (pos>0)
    gtk_paned_set_position(GTK_PANED(wid),pos);

  g_key_file_free (p_key_file);
 
}


void
fin_pgm(GtkWidget       *widget)
{

  // Sauvegarde de la position dans le fichier de config
  GKeyFile * p_key_file = lectureIniFile();

  gint root_x;
  gint root_y;
  GtkWidget *wid;
  wid = lookup_widget(GTK_WIDGET(widget), "princ");
  gtk_window_get_position(GTK_WINDOW(wid), &root_x, &root_y);
   
  gint width;
  gint height;
  gtk_window_get_size(GTK_WINDOW(wid),&width,&height);

  g_key_file_set_integer (p_key_file, "APA-GUI", "x", (int) root_x);
  g_key_file_set_integer (p_key_file, "APA-GUI", "y", (int) root_y);
  g_key_file_set_integer (p_key_file, "APA-GUI", "width", (int) width);
  g_key_file_set_integer (p_key_file, "APA-GUI", "height", (int) height);

  GtkWidget *WorkPath;
  WorkPath = lookup_widget(GTK_WIDGET(widget), "WorkPath");
  g_key_file_set_string (p_key_file,
			 "APA-GUI", "workingpath",
			 gtk_entry_get_text(GTK_ENTRY(WorkPath)));
  
  wid = lookup_widget(GTK_WIDGET(widget), "vpaned2");
  gint pos = gtk_paned_get_position(GTK_PANED(wid));
  g_key_file_set_integer (p_key_file, "APA-GUI", "vpaned2", (int)pos);
  
  gchar *  s_data;
  gsize       size;
  GError *  p_error = NULL;
  
  /* ----- Convert data to string */
  s_data = g_key_file_to_data (p_key_file, &size, &p_error);

  if (!s_data)
    {
      /* Error, exit program. */
      g_warning ("Impossible to convert data to string : %s\n", p_error->message);
      g_error_free (p_error);
      
      exit (EXIT_FAILURE);
    }
  gboolean b_ret;

  // Ecriture du fichier
  
  p_error = NULL;
  gchar text[512];
  sprintf(text,"%s/.apa.ini",getenv("HOME"));
  
  if (! g_file_set_contents (text, s_data, size, &p_error))
    if (! g_file_set_contents (PACKAGE_DATA_DIR "/" PACKAGE "/apa.ini", s_data, size, &p_error))
      if (! g_file_set_contents ("apa.ini", s_data, size, &p_error))
	
	{
	  /* Error, exit program. */
	  g_warning ("Impossible to write config file : %s\n", p_error->message);
	  g_error_free (p_error);

	  exit (EXIT_FAILURE);
	}

  g_free (s_data);
  g_key_file_free (p_key_file);
  gtk_main_quit();
}


void
on_quitter1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  fin_pgm(GTK_WIDGET(menuitem));
}

void
on_quit_clicked                        (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  fin_pgm(GTK_WIDGET(toolbutton));
}


void
on_princ_destroy                       (GtkObject       *object,
                                        gpointer         user_data)
{
  fin_pgm(GTK_WIDGET(object));
}

void
on_FctVisu_changed                     (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
  gint choix = gtk_combo_box_get_active            (combobox);
  printf("Choix %i",choix);fflush(stdout);
  if (choix!=-1)
    fct_courante = choix;
  else
    fct_courante = FCT_NORM;

  GtkWidget *widget;
  widget = lookup_widget(GTK_WIDGET(combobox), "image");
  gtk_widget_queue_draw (widget);

}


void HistoPixbuf()
{
  
  gfloat * red;
  gfloat * green;
  gfloat * blue;
  gfloat * moy;
  guchar * courbe;
  
  gint l = 256;
  gint w = 150;
 
  if (hstRGB) gdk_pixbuf_unref(hstRGB);
  if (hstR) gdk_pixbuf_unref(hstR);
  if (hstG) gdk_pixbuf_unref(hstG);
  if (hstB) gdk_pixbuf_unref(hstB);
  
  hstRGB = gdk_pixbuf_new(GDK_COLORSPACE_RGB,TRUE,8,l,w);
  hstR = gdk_pixbuf_new(GDK_COLORSPACE_RGB,TRUE,8,l,w);
  hstG = gdk_pixbuf_new(GDK_COLORSPACE_RGB,TRUE,8,l,w);
  hstB = gdk_pixbuf_new(GDK_COLORSPACE_RGB,TRUE,8,l,w);

  // Histogramme initialisation
  red = malloc(l*sizeof(gfloat));
  green = malloc(l*sizeof(gfloat));
  blue = malloc(l*sizeof(gfloat));
  moy = malloc(l*sizeof(gfloat));
  courbe = malloc(l*sizeof(gfloat));
  
  gint i,j;
  for (i=0;i<l;i++)
    red[i]=green[i]=blue[i]=0.0;

  //Histogramme
  _ImVal ImVal  = DefImVal(&im);
  _FctVisu FctVisu  = DefFctVisu();

  uint16 x,y;
  uint16 R,G,B;

  R=0; G=0; B=0;
  guchar R255,G255 ,B255,m;
  R255 = 0; G255=0; B255=0;

  gdouble v;
  float t;
  t=255.0/(float)(seuil_h-seuil_b);

  for (y=0;y<im.height;y++)
    for (x=0;x<im.width;x++)
      {
	(ImVal)(&im,x,y,&R,&G,&B);
	
	v=calculRGB( ImVal, FctVisu,
		     x, y,v, t,
		     &R255, &G255,&B255 );
	m = (R255+G255+B255)/3;
	red[R255]++;
	green[G255]++;
	blue[B255]++;
	moy[m]++;

      }
  gdouble MAll,ecartType;  

  MAll =0;
  ecartType=0;
  // On ne compte pas les extremes dans l'histogramme
  for (i=1;i<254;i++)
    {
      MAll+=moy[i];
      ecartType+=moy[i]*moy[i];
    }
  MAll/=255;
  ecartType/=255;
  ecartType = sqrt(ecartType-MAll*MAll);
  MAll+=ecartType;
  MAll+=ecartType;
  MAll+=ecartType;

  float a,c;
  for (i=0;i<255;i++)
    {
      red[i]=red[i]*w/MAll;
      green[i]=green[i]*w/MAll;
      blue[i]=blue[i]*w/MAll;
      moy[i]=moy[i]*w/MAll;

      a=i*(seuil_h-seuil_b)/255.0+seuil_b;
      c=(FonctionVisualisation(a)-seuil_b)*255.0/(seuil_h-seuil_b);
      courbe[i]=c<0?0:c>254.0?(guchar)w:(guchar)c*w/255.0;
  /*     printf(" i %i a %f -> %f c %f -> %i \n", */
/* 	     i,a,FonctionVisualisation(a),c,courbe[i]); */
    }

  int width, height, rowstride, n_channels;
  guchar *pixels, *p;
  

  //Cration de l'image

  guchar *pixelsRGB,*pixelsR,*pixelsG,*pixelsB ;  

  n_channels = gdk_pixbuf_get_n_channels (hstR);
  width = gdk_pixbuf_get_width (hstR);
  height = gdk_pixbuf_get_height (hstR);
  rowstride = gdk_pixbuf_get_rowstride (hstR);
  pixelsRGB = gdk_pixbuf_get_pixels (hstRGB);
  pixelsR = gdk_pixbuf_get_pixels (hstR);
  pixelsG = gdk_pixbuf_get_pixels (hstG);
  pixelsB = gdk_pixbuf_get_pixels (hstB);

  for (i=0;i<l;i++)
    {
      for (j=0;j<w ;j++)
	{
	  // RGB
	  p = pixelsRGB + (w-j-1) * rowstride + i * n_channels;
	  //printf("i %i \n",w-j);fflush(stdout);
	  if (j<moy[i])
	    {
	      p[0] = 0;   p[1] = 0;   p[2] = 0;
	    }
	  else
	    {
	      p[0] = 255;   p[1] = 255;   p[2] = 255;
	    }
	  p[3] = 255;
	  
	  if (j==courbe[i])
	    {
	      p[0] = 200; p[1] = 200;  p[2] = 200;
	    }

	  // R
	  p = pixelsR + (w-j-1) * rowstride + i * n_channels;
	  //printf("i %i \n",w-j);fflush(stdout);
	  if (j<red[i])
	    {
	      p[0] = 255;    p[1] = 0;  p[2] = 0;
	    }
	  else
	    {
	      p[0] = 255;  p[1] = 255;  p[2] = 255;
	    }
	  p[3] = 255;

	  if (j==courbe[i])
	    {
	      p[0] = 0; p[1] = 0;  p[2] = 0;
	    }

	  // G
	  p = pixelsG + (w-j-1) * rowstride + i * n_channels;
	  //printf("i %i \n",w-j);fflush(stdout);
	  if (j<green[i])
	    {
	      p[0] = 0;  p[1] = 255;  p[2] = 0;
	    }
	  else
	    {
	      p[0] = 255;  p[1] = 255; p[2] = 255;
	    }
	  p[3] = 255;
	  if (j==courbe[i])
	    {
	      p[0] = 0;  p[1] = 0;  p[2] = 0;
	    }
	  // B
	  p = pixelsB + (w-j-1) * rowstride + i * n_channels;
	  //printf("i %i \n",w-j);fflush(stdout);
	  if (j<blue[i])
	    {
	      p[0] = 0; p[1] = 0; p[2] = 255;
	    }
	  else
	    {
	      p[0] = 255; p[1] = 255; p[2] = 255;
	    }
	  p[3] = 255;
	  if (j==courbe[i])
	    {
	      p[0] = 0; p[1] = 0; p[2] = 0;
	    }
	  
	}
    }
  
  free(red);
  free(green);
  free(blue);
  free(moy);
  free(courbe);

}

gboolean
on_HistoRGB_expose_event               (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  return FALSE;
}


gboolean
on_HistoR_expose_event                 (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  
  return FALSE;
}


gboolean
on_HistoG_expose_event                 (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  
  return FALSE;
}


gboolean
on_HistoB_expose_event                 (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  
  return FALSE;
}


void
on_HistoMAJ_clicked                    (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  
  // Histogramme
  HistoPixbuf();
  GtkWidget *w;
  w= lookup_widget(GTK_WIDGET(toolbutton), "HistoRGB");
  gtk_image_set_from_pixbuf (GTK_IMAGE(w) , hstRGB);
  w= lookup_widget(GTK_WIDGET(toolbutton), "HistoR");
  gtk_image_set_from_pixbuf (GTK_IMAGE(w) , hstR);
  w= lookup_widget(GTK_WIDGET(toolbutton), "HistoG");
  gtk_image_set_from_pixbuf (GTK_IMAGE(w) , hstG);
  w= lookup_widget(GTK_WIDGET(toolbutton), "HistoB");
  gtk_image_set_from_pixbuf (GTK_IMAGE(w) , hstB);

}



void
on_crop_clicked                        (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{

  // carre de la selection
  if (selection.etat==INACTIF)
    {
      majStatusBar(GTK_WIDGET(toolbutton),"Attention ! Pas de selection !");
    }
  else
    {
      int x1,x2,y1,y2;

      gtk_grab_add (GTK_WIDGET(toolbutton));
      majStatusBar(GTK_WIDGET(toolbutton),"Crop de l'image ...");
     
      
      x1=selection.x1*facteur;
      x2=selection.x2*facteur;
      y1=selection.y1*facteur;
      y2=selection.y2*facteur;

      printf("Crop %i %i %i %i %i %i\n",x1,y1,x2,y2,x2-x1,y2-y1);

      x1=x1<0?0:x1>im.width?im.width:x1;
      x2=x2<0?0:x2>im.width?im.width:x2;


      y1=y1<0?0:y1>im.height?im.height:y1;
      y2=y2<0?0:y2>im.height?im.height:y2;

      printf("Crop %i %i %i %i %i %i\n",x1,y1,x2,y2,x2-x1,y2-y1);
            
      gdouble vMax;

      if (((x2 - x1)>0) && ((y2 - y1)>0)) 
	{
         
	  struct image * cr;
	  cr = cropImage(&im, x1, y1,x2 - x1, y2-y1);
	  if (cr!=NULL)
	    {
	      if (pixbuf) gdk_pixbuf_unref(pixbuf);
	      if (im.buffer!=NULL)free(im.buffer);
	      
	      copyImage(cr, &im);
	      im.buffer=cr->buffer;
	      selection.etat=INACTIF;

	      vMax = creation_pixbuf(GTK_WIDGET(toolbutton));
	    }
	}
      majStatusBar(GTK_WIDGET(toolbutton),"Ok");
      gtk_grab_remove (GTK_WIDGET(toolbutton));
    }

}


void
on_ChgWorkPath_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget * FileChooser;
  GtkWidget *princ;
  GtkWidget *WorkPath;
  princ = lookup_widget(GTK_WIDGET(button), "princ");
  FileChooser = gtk_file_chooser_dialog_new("APA Choix du rpertoire de travail",
					    GTK_WINDOW(princ),
					    GTK_FILE_CHOOSER_ACTION_CREATE_FOLDER,
					    GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
					    GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
					    NULL);
  gtk_file_chooser_set_do_overwrite_confirmation (GTK_FILE_CHOOSER (FileChooser), TRUE);
  WorkPath = lookup_widget(GTK_WIDGET(button), "WorkPath");

  gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (FileChooser), 
				       gtk_entry_get_text (GTK_ENTRY(WorkPath)));
  
  if (gtk_dialog_run (GTK_DIALOG (FileChooser)) == GTK_RESPONSE_ACCEPT)
    {

      char *filename; 
      filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (FileChooser));
      printf("Repertoire %s\n",filename);
      gtk_entry_set_text (GTK_ENTRY(WorkPath), filename);

      g_free (filename);
    }
  gtk_widget_destroy (FileChooser);

}


void
on_WorkPath_changed                    (GtkEditable     *editable,
                                        gpointer         user_data)
{
  GError *  p_error = NULL;


  

  // Lecture des repertoires darks,offsets,flats
/*   if (g_chdir (gtk_entry_get_text (GTK_ENTRY(editable)))) */
/*     { */

  gchar text[512];
  sprintf(text,"%s/%s",gtk_entry_get_text (GTK_ENTRY(editable)),REPERTOIRES[OFFSETS]);
  printf("%s\n",text);  fflush(stdout);
  GDir *dir = g_dir_open (text, 
			  0,&p_error);
  
  if (!dir)
    {
      g_printf ("Erreur : %s\n", p_error->message);
      g_error_free (p_error);
    }
  else
    
    {
      const gchar *objet = NULL;
      while (objet = g_dir_read_name (dir))
	{
	  printf("%s\n",objet);
	  
	  
	}
    }
  fflush(stdout);

  
}


void
on_doOffset_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_doDark_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_doFlat_toggled                      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}

