#include <stdlib.h>
#include <stdio.h>
#include <tiffio.h>
#include <tiff.h>

#include "api.h"

char * Version()
{
  return "0.9";
}

struct filtre *  Name()
{
  struct filtre *f;
  f=malloc(sizeof(struct filtre));
  f->name="DDP";
  f->desc="DDP";
  return f;
}

struct parametre * Init()
{
  struct parametre *a;
  a=malloc(sizeof(struct parametre));
  a->name="a";
  a->desc="a en % du seuil ex(90%)";
  a->type=INT;
  a->intvalue=90;
  a->floatvalue=0.0;


  struct parametre *b;
  b=malloc(sizeof(struct parametre));
  b->name="b";
  b->desc="b";
  b->type=INT;
  b->intvalue=0;
  b->floatvalue=0.0;
 
  struct parametre *k;
  k=malloc(sizeof(struct parametre));
  k->name="seuil";
  k->desc="seuil de visualisation ";
  k->type=INT;
  k->intvalue=20000;
  k->floatvalue=0.0;

  struct parametre *r;
  r=malloc(sizeof(struct parametre));
  r->name="r";
  r->desc="r";
  r->type=INT;
  r->intvalue=1;
  r->floatvalue=0.0;

  r->next=NULL;

  a->next=b;
  b->next=k;
  k->next=r;

  return a;
}

double * creerNoyauGaussien(int rayon, double sigma)
{
  /*
    kernel : Noyau de convolution de taille 
    largeur = 2*rayon+1
    hauteur = 2*rayon+1
    et centr en (rayon, rayon)
  */
  double *kernel;
  kernel = malloc(sizeof(int)*(2*rayon+1)*(2*rayon+1));
  
  if (sigma == 0) return NULL;
  if (rayon<1) return NULL;
  double gaussianKernelFactor =0;
  double e=0;
  
  int ky,kx;
  unsigned int p;
  for (ky=-rayon;ky<(rayon+1);ky++)
    {
      for (kx=-rayon;kx<(rayon+1);kx++)
	{
	  e =  exp( - (kx*kx+ky*ky) / (2*sigma*sigma));
	  gaussianKernelFactor =  gaussianKernelFactor  + e;
	  p = (kx+rayon)*(2*rayon+1)+ky+rayon;
	  kernel[p]= e  ;
	  printf("%f ",kernel[p]);
	    }
      printf("\n");
    }
  fflush(stdout);
  
  /*on divise tout par le facteur afin que la somme de tous les lments
   * soient gaux  1
   */
  //printf("%f\n",kx,ky,gaussianKernelFactor);fflush(stdout);
  for (ky=-rayon;ky<(rayon+1);ky++)
    for (kx=-rayon;kx<(rayon+1);kx++)
      {
	p = (kx+rayon)*(2*rayon+1)+ky+rayon;
	kernel[p]/= gaussianKernelFactor ;
	//printf (" kernel (%i,%i) %f\n",kx,ky,kernel[p]);
      }
  
  return kernel;
}

int  Do(struct image * source, 
	struct image * destination,
	int X, int Y,
	int Larg, int Haut,
	struct parametre * p)
{
  int rayon;
  rayon = 1;

  int a,b,seuil;
  double k;
  a=10;
  b=0;
  seuil=10;

  struct parametre *point;
  point=p;
  while (point!=NULL)
    {
      if (strcmp(point->name,"seuil")==0)
	seuil=point->intvalue;
      if (strcmp(point->name,"b")==0)
	b=point->intvalue;
      if (strcmp(point->name,"a")==0)
	a=point->intvalue;
      if (strcmp(point->name,"r")==0)
	rayon=point->intvalue;
      point=point->next;
    }
  printf("DDP %i,%i,%i\n",source->sampleParPixel,source->bps,Haut);

  // On deduie a en fonction du seuil
  a = seuil*a/100;
  k = (seuil-b)*(seuil+a)/(a*seuil);
  printf("parametre %i %i %f\n",a,seuil, k);fflush(stdout);
  double *kernel;
  kernel = creerNoyauGaussien(rayon,1.2);
  

  unsigned long x,y,count;
  // Que pour des images RGB en 16 bits pour l'instant
  uint16 R,G,B;
  double Rm,Gm,Bm;
  int ky,kx;
  unsigned int pp;
  double cR,cG,cB;

  // Recherche de la fonction de recherche d'une valeur d'un pixel
  _ImVal ImVal  = DefImVal(source);
  // Recherche de la fonction de maj d'une valeur d'un pixel
  _ImMaj ImMaj  = DefImMaj(destination);
  
  if (source->sampleParPixel==3)
    if (source->bps==16)
      {

	// Calcul des coef
	for (y=Y;y<(Y+Haut);y++)
	  for (x=X;x<(X+Larg);x++)
	    {
	      //count = y*source->width+ x;

	      //Unsharpen (blur) X : this is {X}
	      // Flou par moyenne
	      cR =0.0;
	      cG =0.0; 
	      cB =0.0;
	      for (ky=-rayon;ky<(rayon+1);ky++)
		for (kx=-rayon;kx<(rayon+1);kx++)
		  {

		    (ImVal)(source,x+kx,y+ky,&R,&G,&B);
		    
		    pp = (kx+rayon)*(2*rayon+1)+ky+rayon;
		    //count = (y+ky)*source->width+ (x+kx);
		    //R=source->buffer[count*6]+256*source->buffer[count*6+1];
		    //G=source->buffer[count*6+2]+256*source->buffer[count*6+3];
		    //B=source->buffer[count*6+4]+256*source->buffer[count*6+5];
		    cR+=R*kernel[pp];
		    cG+=G*kernel[pp];
		    cB+=B*kernel[pp];
		    if (((x)==2062)&&((y)==1312))
		      printf("ici (%i,%i) %i %i %i %f %f %i\n",x+kx,y+ky,
			     x,y, R, kernel[pp], cR,pp);
		    
		    
		  }
	      //fflush(stdout);
	      
	      Rm = cR;
	      Gm = cG;
	      Bm = cB;

	      if ((x==2062)&&(y==1312))
		{
		  printf("(%i %i)-> %i %f %f \n",x,y,R,Rm,cR);fflush(stdout);
		}

/* 	      //Make {X}+a (simply add 'a') */
	      Rm = Rm + (double)a;
	      Gm = Gm + (double)a;
	      Bm = Bm + (double)a;
/* 	      if ((x==X)&&(y==Y)) */
/* 		{ */
/* 		  printf("(%i %i)-> %f %f \n",x,y,Rm,cR);fflush(stdout); */
/* 		} */
/* 	      //X/[{X}+a}]. */
	      (ImVal)(source,x,y,&R,&G,&B);
/* 	      //count = y*source->width+x; */
/* 	      /\* 	      R=source->buffer[count*6]+256*source->buffer[count*6+1]; *\/ */
/* 	      /\* 	      G=source->buffer[count*6+2]+256*source->buffer[count*6+3]; *\/ */
/* 	      /\* 	      B=source->buffer[count*6+4]+256*source->buffer[count*6+5]; *\/ */
	      
	      Rm=k*a*R/Rm;
	      Gm=k*a*G/Gm;
	      Bm=k*a*B/Bm;
/* 	      if ((x==X)&&(y==Y)) */
/* 		{ */
/* 		  printf("(%i %i)-> %f %i \n",x,y,Rm,R);fflush(stdout); */
/* 		} */
/* 	      //Add a pedestal 'b' to X/[{X}+a] */
	      Rm +=b;
	      Gm +=b;
	      Bm +=b;
	      
/* 	      //NouvelleValeur = Coefficient * Niveau * (ValeurAvant / (<ValeurAvant affect du filtre passe bas ou gaussien> + Niveau)) */

/* /\* 	      R=Rm; *\/ */
/* /\* 	      G=Gm; *\/ */
/* /\* 	      B=Bm; *\/ */

/* 	      // Test sans blur */

/* /\* 	      R=k*R/(R+a)+b; *\/ */
/* /\* 	      G=k*G/(G+a)+b; *\/ */
/* /\* 	      B=k*B/(B+a)+b; *\/ */
	      
	      R=Rm>65535?65535:Rm<0?0:(uint16)Rm;
	      G=Gm>65535?65535:Gm<0?0:(uint16)Gm;
	      B=Bm>65535?65535:Bm<0?0:(uint16)Bm;

	      (ImMaj)(destination,x,y,R,G,B);
	    
	    }
      }
}


  


