#include <stdlib.h>
#include <stdio.h>
#include <tiffio.h>
#include <tiff.h>

#include "api.h"

char * Version()
{
  return "0.9";
}

struct filtre *  Name()
{
  struct filtre *f;
  f=malloc(sizeof(struct filtre));
  f->name="BalanceRGB";
  f->desc="Application d'une balance par coefficient sur les canaux RGB";
  return f;
}

struct parametre * Init()
{
  struct parametre *r;
  r=malloc(sizeof(struct parametre));
  r->name="R";
  r->desc="Coefficent multiplicateur pour le Rouge";
  r->type=FLOAT;
  r->intvalue=0;
  r->floatvalue=1.0;
  

  struct parametre *g;
  g=malloc(sizeof(struct parametre));
  g->name="G";
  g->desc="Coefficent multiplicateur pour le Vert";
  g->type=FLOAT;
  g->intvalue=0;
  g->floatvalue=1.0;
  

  struct parametre *b;
  b=malloc(sizeof(struct parametre));
  b->name="B";
  b->desc="Coefficent multiplicateur pour le Bleu";
  b->type=FLOAT;
  b->intvalue=0;
  b->floatvalue=1.0;
  b->next=NULL;

  r->next=g;
  g->next=b;

  return r;
}

int  Do(struct image * source, 
	struct image * destination,
	int X, int Y,
	int Larg, int Haut,
	struct parametre * p)
{
 
  float cR,cG,cB;
  cR=2.5;
  cG=1.25;
  cB=2.0;


  struct parametre * par;
  par = p;
  
  while (par!=NULL)
    {
      if (strcmp(par->name,"R")) cR=par->floatvalue;
      if (strcmp(par->name,"G")) cG=par->floatvalue;
      if (strcmp(par->name,"B")) cB=par->floatvalue;
      par=par->next;
    }
  
  printf("Balance GGB %f,%f,%f\n",cR,cG,cB);fflush(stdout);
  

  unsigned long x,y,count;
  // Que pour des images RGB en 16 bits pour l'instant
  int32 vR,vG,vB;


  uint16 R,G,B;

  // Recherche de la fonction de recherche d'une valeur d'un pixel
  _ImVal ImVal  = DefImVal(source);
  // Recherche de la fonction de maj d'une valeur d'un pixel
  _ImMaj ImMaj  = DefImMaj(destination);
  
  // Calcul des coef
  for (y=Y;y<(Y+Haut);y++)
    for (x=X;x<(X+Larg);x++)
      {
	(ImVal)(source,x,y,&R,&G,&B);
	
	vR=cR*R;
	vG=cG*G;
	vB=cB*B;

	R=vR>65535?65535:vR<0?0:vR;
	G=vG>65535?65535:vG<0?0:vG;
	B=vB>65535?65535:vB<0?0:vB;

	(ImMaj)(destination,x,y,R,G,B);
      }
}
