#include <stdlib.h>
#include <stdio.h>
#include <tiffio.h>
#include <tiff.h>

#include "api.h"

char * Version()
{
  return "0.9";
}

struct filtre *  Name()
{
  struct filtre *f;
  f=malloc(sizeof(struct filtre));
  f->name="Flat";
  f->desc="Calcul un flat et le soustrait a l'image";
  return f;
}

struct parametre * Init()
{
  struct parametre *p;
  p=malloc(sizeof(struct parametre));
  p->name="cadrillage";
  p->desc="Nombre de carre dans largeur de l'image";
  p->type=INT;
  p->intvalue=5;
  p->floatvalue=0.0;
  
  struct parametre *v;
  v=malloc(sizeof(struct parametre));
  v->name="application/visualisation";
  v->desc="0 Visu du flat 1 Application du fltat";
  v->type=INT;
  v->intvalue=1;
  v->floatvalue=0.0;
  
  struct parametre *c;
  c=malloc(sizeof(struct parametre));
  c->name="vCoupure";
  c->desc="Les pixels dont l'intensite est plus grande que ce seuil ne sont pas pris en compte pour le calcul du flat";
  c->type=INT;
  c->intvalue=65535;
  c->floatvalue=0.0;

  c->next=NULL;
  v->next=c;
  p->next=v;

  return p;
}

enum les_coefs
  {
    C_1,
    C_x,
    C_y,
    C_xx,
    C_yy,
    C_xy,
    C_xxx,
    C_yyy
  }; 

int  Do(struct image * source, 
	struct image * destination,
	int X, int Y,
	int Larg, int Haut,
	struct parametre * p)
{
 
  printf("Flat %i,%i,%i\n",source->sampleParPixel,source->bps,Haut);
  // On calcul une fonction z=a+bx+cy qui interpole l'image

  printf("Version :%s\n",Version());

  int N=6;
  
  int a=10;
  int b;
  int visu = 1;
  uint16 vC=65535;

  
  struct parametre *point;
  point=p;
  while (point!=NULL)
    {
      if (strcmp(point->name,"cadrillage")==0)
	a=point->intvalue;
      if (strcmp(point->name,"application/visualisation")==0)
	visu=point->intvalue;
      if (strcmp(point->name,"vCoupure")==0)
	vC=point->intvalue;
      point=point->next;
    }


  printf(" paramete %i\n",a );fflush(stdout);

  unsigned long x,y,count;
  // Que pour des images RGB en 16 bits pour l'instant
  uint16 R,G,B;

  // Recherche de la fonction de recherche d'une valeur d'un pixel
  _ImVal ImVal  = DefImVal(source);
  // Recherche de la fonction de maj d'une valeur d'un pixel
  _ImMaj ImMaj  = DefImMaj(destination);
  

  uint32 nbValR=0;
  uint32 nbValG=0;
  uint32 nbValB=0;

  double  s[N][3];

  // Calcul du maillage

  int largMaillage;
  largMaillage = Larg/a;
  b=Haut/largMaillage+1;

  printf("%i %i %i\n",a,b,largMaillage);fflush(stdout);

  double *c;
  double moyenneImage;
  c= malloc(sizeof(double)*a*b*3);

  int i,j,k;
  // Initialisation
  
  for (k=0;k<3;k++)
    for (i=0;i<b;i++)
      for (j=0;j<a;j++)
	c[(i*a+j)+k*a*b]=0.0;

  if (source->bps==16)
    if (source->sampleParPixel==3)
      {

	unsigned long t;
	int m,n;
	moyenneImage=0.0;
	for (i=0;i<b;i++)
	  for (j=0;j<a;j++)
	    {
	      m = Y+(i+1)*largMaillage;
	      m = m >(Y+Haut)? (Y+Haut):m;
	      
	      t=0;
	      for (y=Y+i*largMaillage;y<m;y++)
		{
		  n = X+(j+1)*largMaillage;
		  n = n >(X+Larg)? (X+Larg):n;  
		  for (x=X+j*largMaillage;x<n;x++)
		    {

		      (ImVal)(source,x,y,&R,&G,&B);
		      
		      if ((R+G+B)/3<vC)
			{
		      
			  c[(i*a+j)+pR*a*b]+=(double) R;
			  c[(i*a+j)+pG*a*b]+=(double) G;
			  c[(i*a+j)+pB*a*b]+=(double) B;
			  t++;
			}
 
		    }
		}
	      if (t!=0)
		{
		  c[i*a+j+pR*a*b]/=t;
		  c[i*a+j+pG*a*b]/=t;
		  c[i*a+j+pB*a*b]/=t;
		  moyenneImage+=c[i*a+j+pR*a*b]+c[i*a+j+pG*a*b]+c[i*a+j+pB*a*b];
		}

	      //printf("(%i,%i) %i %f %i %i\n",i,j,t,c[i*a+j+pG*a*b],m,n);
	    }
	
	moyenneImage = moyenneImage / (3*(double)a * (double) b);
	//printf("moyenneImage %i %i %i  %f %i \n",a,b,a*b,moyenneImage,a*b);fflush(stdout);	
	
	// Calcul des coeeficients methode moindre carre
	double e[7][6][3];

	// Initialisation
	for (i=0;i<(N+1);i++) 
	  for (j=0;j<N;j++)
	    for (k=0;k<3;k++)
	      e[i][j][k]=0.0;
	
	// Calcul des coef

	// 1 x y x*x y*y x*y x*x*x y*y*y 
	
	for (i=0;i<b;i++)
	  for (j=0;j<a;j++)
	    {
	      y=Y+i*largMaillage+largMaillage/2;
	      x=X+j*largMaillage+largMaillage/2;
	      
	      //printf("%i %i \n",x,y);
	      for (k=0;k<3;k++)
		{
		  int q,r;
		  double v1=0.0;
		  double v2=0.0;
		  for (r=0;r<N;r++)
		    {
		      if (r==C_1) v1=1;
		      if (r==C_x) v1=x;
		      if (r==C_y) v1=y;
		      if (r==C_xx) v1=x*x;
		      if (r==C_yy) v1=y*y;
		      if (r==C_xy) v1=x*y;
		      if (r==C_xxx) v1=x*x*x;
		      if (r==C_yyy) v1=y*y*y;
		      
		      
		      for (q=0;q<(N+1);q++)
			{
			  if (q==C_1) v2=1;
			  if (q==C_x) v2=x;
			  if (q==C_y) v2=y;
			  if (q==C_xx) v2=x*x;
			  if (q==C_yy) v2=y*y;
			  if (q==C_xy) v2=x*y;
			  if (q==C_xxx) v2=x*x*x;
			  if (q==C_yyy) v2=y*y*y;
			  if (q==N) v2= c[i*a+j+k*a*b];
			  
			  e[q][r][k]+= v1*v2;
			  //printf("e (%i,%i,%i)\n",q,r,k);
			}
		    }
		}
	    }
	
	int a,tt,ligne,sol;
	double temp;
	for (k=0;k<3;k++) // 3 plan
	  {
	    // Resoudre par pivot de Gauss
	    
	    
	    for(i=0; i<N-1; i++){
	      for(a=1+i; a<N; a++){
		
		temp=e[i][a][k];
		for (tt=i; tt<N+1; tt++){
		  
		  // On triangularise le systeme
		  
		  e[tt][a][k] = e[tt][a][k] * e[i][i][k] - e[tt][i][k] * temp;
		  
		}
		
	      }
	    }

	    // On remplace
	    s[N-1][k] = e[N][N-1][k] / e[N-1][N-1][k];
	    e[N][N-1][k]=0;
	    e[N-1][N-1][k]=0;
	    
	    for (ligne=1; ligne<=N; ligne++)
	      {
		for (sol=2; sol<=N; sol++)
		  {
		    e[N-ligne][N-sol][k] *= s[N-ligne][k];
		    e[N][N-sol][k] -= e[N-ligne][N-sol][k];
		    e[N-ligne][N-sol][k]=0;
		    
		  }
		
		s[N-(ligne+1)][k] = e[N][N-(ligne+1)][k] /
		  e[N-(ligne+1)][N-(ligne+1)][k];
		
	      }
	    
	    printf("Resultat plan %i %f %f %f  %f %f %f \n",k,
		   s[0][k],s[1][k],s[2][k],
		   s[3][k],s[4][k],s[5][k]);
	  }


	// Calculer la nouvelle image
	for (y=Y;y<(Y+Haut);y++)
	  for (x=X;x<(X+Larg);x++)
	    {
	      count = y*destination->width+ x;
	      double tR,tG,tB;

	      // Flat
	      tR = s[0][pR]+s[1][pR]*x+s[2][pR]*y +s[3][pR]*x*x+s[4][pR]*y*y +s[5][pR]*x*y;
	      tG = s[0][pG]+s[1][pG]*x+s[2][pG]*y +s[3][pG]*x*x+s[4][pG]*y*y +s[5][pG]*x*y;
	      tB = s[0][pB]+s[1][pB]*x+s[2][pB]*y +s[3][pB]*x*x+s[4][pB]*y*y+s[5][pB]*x*y ;

	      // Pixel
	      (ImVal)(source,x,y,&R,&G,&B);

	      if (visu==0) 
		{
		  R = (uint16)tR;
		  G = (uint16)tG;
		  B = (uint16)tB;
		}
	      else
		{
		  tR = R*moyenneImage/tR ;
		  tG = G*moyenneImage/tG ;
		  tB = B*moyenneImage/tB ;
		  
		  R = tR<0.0?0:tR>65535.0?65535:(uint16)tR;
		  G = tG<0.0?0:tG>65535.0?65535:(uint16)tG;
		  B = tB<0.0?0:tB>65535.0?65535:(uint16)tB;      
		}
	      (ImMaj)(destination,x,y,R,G,B);

	    }
      }

}
