#include <stdlib.h>
#include <stdio.h>
#include <tiffio.h>
#include <tiff.h>

#include "api.h"

char * Version()
{
  // Version de l'api utilise
  return "0.9";
}


struct filtre *  Name()
{
  struct filtre *f;
  f=malloc(sizeof(struct filtre));
  f->name="Gradient";
  f->desc="Supprime le gradient d'une image";
  return f;
}

struct parametre * Init()
{
  struct parametre *p;
  p=malloc(sizeof(struct parametre));
  p->name="vCoupure";
  p->desc="Les pixels dont l'intensite est plus grande que ce seuil ne sont pas pris en compte pour le calcul du gradient";
  p->type=INT;
  p->intvalue=65535;
  p->floatvalue=0.0;
  p->next=NULL;
  return p;
}

int  Do(struct image * source, 
	struct image * destination,
	int X, int Y,
	int Larg, int Haut,
	struct parametre * p)
{
 
  printf("Gradient %i,%i,%i\n",source->sampleParPixel,source->bps,Haut);
  // On calcul une fonction z=a+bx+cy qui interpole l'image
  
  float vCoupure=65535;
  if (p!=NULL)
    vCoupure=p->intvalue;
  if (p==NULL)
    printf(" pas de paramete \n");
  else
    printf(" paramete %i\n",p->intvalue );
  printf("et la  ? %d",p);fflush(stdout);
  // On refait un petit offset 
  int OFFSET = 50;

  unsigned long x,y;
  // Que pour des images RGB en 16 bits pour l'instant
  uint16 R,G,B;

  // Recherche de la fonction de recherche d'une valeur d'un pixel
  _ImVal ImVal  = DefImVal(source);
  // Recherche de la fonction de maj d'une valeur d'un pixel
  _ImMaj ImMaj  = DefImMaj(destination);
  

  uint32 nbValR=0;
  uint32 nbValG=0;
  uint32 nbValB=0;

  double s[3][3];
  double v;
  if (source->sampleParPixel==3)
    if (source->bps==16)
      {


	// Calcul des coeeficients methode moindre carre
	double e[4][3][3];
	int i,j,k;
	// Initialisation
	for (i=0;i<4;i++) 
	  for (j=0;j<3;j++)
	    for (k=0;k<3;k++)
	      e[i][j][k]=0.0;
	

	// Calcul des coef
	for (y=Y;y<(Y+Haut);y++)
	  for (x=X;x<(X+Larg);x++)
	    {
	      (ImVal)(source,x,y,&R,&G,&B);
	      //count = y*source->width+ x;
	      //R=source->buffer[count*6]+256*source->buffer[count*6+1];
	      //G=source->buffer[count*6+2]+256*source->buffer[count*6+3];
	      //B=source->buffer[count*6+4]+256*source->buffer[count*6+5];

	      if (R<vCoupure)
		{
		  nbValR++;
		  // Rouge
		  // Equation 1
		  e[0][0][pR]+=1;
		  e[1][0][pR]+=x;
		  e[2][0][pR]+=y;
		  e[3][0][pR]+=R;
		  // Equation 2
		  e[0][1][pR]+=x;
		  e[1][1][pR]+=x*x;
		  e[2][1][pR]+=x*y;
		  e[3][1][pR]+=x*R;
		  // Equation 3
		  e[0][2][pR]+=y;
		  e[1][2][pR]+=x*y;
		  e[2][2][pR]+=y*y;
		  e[3][2][pR]+=y*R;
		}
	      if (G<vCoupure)
		{
		  nbValG++;
		  // Vert
		  // Equation 1
		  e[0][0][pG]+=1;
		  e[1][0][pG]+=x;
		  e[2][0][pG]+=y;
		  e[3][0][pG]+=G;
		  // Equation 2
		  e[0][1][pG]+=x;
		  e[1][1][pG]+=x*x;
		  e[2][1][pG]+=x*y;
		  e[3][1][pG]+=x*G;
		  // Equation 3
		  e[0][2][pG]+=y;
		  e[1][2][pG]+=x*y;
		  e[2][2][pG]+=y*y;
		  e[3][2][pG]+=y*G;
		}
	      if (B<vCoupure)
		{
		  nbValB++;
		  // Bleu
		  // Equation 1
		  e[0][0][pB]+=1;
		  e[1][0][pB]+=x;
		  e[2][0][pB]+=y;
		  e[3][0][pB]+=B;
		  // Equation 2
		  e[0][1][pB]+=x;
		  e[1][1][pB]+=x*x;
		  e[2][1][pB]+=x*y;
		  e[3][1][pB]+=x*B;
		  // Equation 3
		  e[0][2][pB]+=y;
		  e[1][2][pB]+=x*y;
		  e[2][2][pB]+=y*y;
		  e[3][2][pB]+=y*B;
		}
	      
	    }
	for (k=0;k<3;k++)
	  {
	    // Resoudre par pivot de Gauss

	    int a,t,ligne,sol;
	    double temp;
	    for(i=0; i<3-1; i++){                
	      for(a=1+i; a<3; a++){
		
		temp=e[i][a][k];
	    for (t=i; t<3+1; t++){
	      
	      
	      // On triangularise le systeme
	      
	      e[t][a][k] = e[t][a][k] * e[i][i][k] - e[t][i][k] * temp;
	      
	    }
	    
	      }
	    }
	    
	    
	    // On remplace
	    s[3-1][k] = e[3][3-1][k] / e[3-1][3-1][k];
	    e[3][3-1][k]=0;
	    e[3-1][3-1][k]=0;
	    
	    for (ligne=1; ligne<=3; ligne++){
	      for (sol=2; sol<=3; sol++){
		e[3-ligne][3-sol][k] *= s[3-ligne][k];
		e[3][3-sol][k] -= e[3-ligne][3-sol][k];
		e[3-ligne][3-sol][k]=0;
		
	      }
	      
	      s[3-(ligne+1)][k] = e[3][3-(ligne+1)][k] /
		e[3-(ligne+1)][3-(ligne+1)][k];
	      
	    }
      
	    printf("Resultat plan %i %f %f %f \n",k,s[0][k],s[1][k],s[2][k]);
	  }

	// Calculer la nouvelle image
	for (y=Y;y<(Y+Haut);y++)
	  for (x=X;x<(X+Larg);x++)
	    {
	      (ImVal)(source,x,y,&R,&G,&B);

	      //count = y*destination->width+ x;

	      R+=OFFSET;
	      v=R-s[0][pR]+s[1][pR]*x+s[2][pR]*y;
	      R=v<0?0:v>65535?65535:(uint16)v;

	      G+=OFFSET;
	      v=G-s[0][pG]+s[1][pG]*x+s[2][pG]*y;
	      G=v<0?0:v>65535?65535:(uint16)v;

	      B+=OFFSET;
	      v=B-s[0][pB]+s[1][pB]*x+s[2][pB]*y;
	      B=v<0?0:v>65535?65535:(uint16)v;

	      // Pixel
	      (ImMaj)(destination,x,y,R,G,B);

	    }
      }
}
