#include <stdlib.h>
#include <stdio.h>
#include <tiffio.h>
#include <tiff.h>
#include <math.h>

#include "api.h"

struct filtre  *  Name()
{
  struct filtre *f;
  f=malloc(sizeof(struct filtre));
  f->name="HotSpot";
  f->desc="Supprime les points qui ont une intensite superieur  la moyenne des voisins + cart type et dont l'intensite est supperieur a un pourcentage de l'intensite maximum de l'image";
  return f;
}


struct parametre * Init()
{
  struct parametre *p;
  p=malloc(sizeof(struct parametre));
  p->name="% de intensite";
  p->desc="Pourcentage de l'intesite maximum de l'iamage. Cette intensite\n\t sert pour diminuer ou agrendir l'aggresivite du flitre.\n\t Les valeurs les plus proche de 100 sont les plus agressive";
  p->type=INT;
  p->intvalue=65535;
  p->floatvalue=0.0;
  p->next=NULL;
  return p;
}

int  Do(struct image * source, 
	struct image * destination,
	int X, int Y,
	int Larg, int Haut,
	struct parametre * p)
{
  
  printf("HotSpot %i,%i,%i\n",source->sampleParPixel,source->bps,Haut);
  // On calcul une fonction z=a+bx+cy qui interpole l'image


  unsigned long x,y,count,c;
  // Que pour des images I  en 16 bits pour l'instant
  int I;
  int cas;
  float v,v2,vi,vCoupure;
  int e;
  int nb=0;
  int iMax;
  int iCoupure;
  
  if (source->sampleParPixel==1)
    if (source->bps==16)
      {
	v = 0;
	v2 =0;
	iMax=0;
	// Stats surl'image
	for (y=Y;y<(Y+Haut);y++)
	  for (x=X;x<(X+Larg);x++)
	    {
	      count = y*source->width+ x;
	      vi=source->buffer[count*2]+256*source->buffer[count*2+1];
	      v+=vi;
	      v2+=vi*vi;
	      if (iMax<vi) iMax = (int)vi;
	    }
	v /=Larg*Haut;
	v2 /= Larg*Haut;
	vCoupure = v+sqrt(v2-v*v);
	iCoupure = (int)iMax*20/100;

	// Ne marche pas sur les bords
	X = X<2 ? 2:X;
	Y = Y<2 ? 2:Y;
	if ((X+Larg)>(source->width-2)) Larg = source->width-2-X;
	if ((Y+Haut)>(source->height-2)) Haut = source->height-2-X;
	
	for (y=Y;y<(Y+Haut);y++)
	  for (x=X;x<(X+Larg);x++)
	    {
	      count = y*source->width+ x;
	      I=source->buffer[count*2]+256*source->buffer[count*2+1];
	      
	      // Decodage Bayer
	      cas=x%2 + (y % 2)*10;
	      // si x pair et y pair 0
	      // si x pair et y impair 10
	      // si x impair et y pair 1
	      // si x impair et y impair 11
 
	      v = 0;
	      v2 =0;
	      
	      if ((cas ==0)|| (cas ==11) )
		{
		  //Rouge ou bleu
		  // Moyenne des rouges autours + ecart type
		  
		  c = (x)+ (y-2)*source->width;
		  vi = source->buffer[c*2]+256*source->buffer[c*2+1];
		  v  += vi;
		  v2 += vi*vi;
		  c = (x)+ (y+2)*source->width;
		  vi = source->buffer[c*2]+256*source->buffer[c*2+1];
		  v  += vi;
		  v2 += vi*vi;
		  c = (x+2)+ (y)*source->width;
		  vi = source->buffer[c*2]+256*source->buffer[c*2+1];
		  v  += vi;
		  v2 += vi*vi;
		  c = (x-2)+ (y)*source->width;
		  vi = source->buffer[c*2]+256*source->buffer[c*2+1];
		  v  += vi;
		  v2 += vi*vi;
		}
	      if ((cas ==10)||(cas ==1))
		{
		  //Vert
		  c = (x+1)+ (y+1)*source->width;
		  vi = source->buffer[c*2]+256*source->buffer[c*2+1];
		  v  += vi;
		  v2 += vi*vi;
		  c = (x+1)+ (y-1)*source->width;
		  vi = source->buffer[c*2]+256*source->buffer[c*2+1];
		  v  += vi;
		  v2 += vi*vi;
		  c = (x-1)+ (y+1)*source->width;
		  vi = source->buffer[c*2]+256*source->buffer[c*2+1];
		  v  += vi;
		  v2 += vi*vi;
		  c = (x-1)+ (y-1)*source->width;
		  vi = source->buffer[c*2]+256*source->buffer[c*2+1];
		  v  += vi;
		  v2 += vi*vi;
		}
	      v /=4;
	      v2 /=4;
	      e = sqrt(v2-v*v);
	      
	      //if (I> v+4*e)
	      if ((I/v> 3)&&(v<vCoupure)&&(I>iCoupure))
		{
		  //printf ("Hot spot en %ix%i R I=%i v=%f e=%i\n",x,y,I,v,e);
		  I=(int)v;
		  nb++;
		}
	      
	    
	
	
	      
	      destination->buffer[count*2+1]=I/256;
	      destination->buffer[count*2]=I-256*destination->buffer[count*2+1];
	    }
	
	printf("Nb de HotSpot = %i vCoupure = %f Imax = %i iCoupure%i\n",nb,vCoupure,iMax,iCoupure);
      }
}


  


