/*
   apa.h -- APA 
   Copyright 2007 by David Laine, david dot laine a free o fr

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
   
 */

#include <stdlib.h> 
#include <stdio.h> 
/* #include <wchar.h> */
#include <tiff.h> 
#include <tiffio.h> 
#include <dirent.h>
#include <math.h> 
#include <string.h> 
#include "image.h"


#ifndef A_IMAGE
#define A_IMAGE

#define A_TRUE 1
#define A_FALSE 0

#define NBOBJ 20
#define EPSILON 0.00004

//#define BALANCE_R 2.5
//#define BALANCE_G 1.25
//#define BALANCE_B 2.0

#define BALANCE_R 1.0
#define BALANCE_G 1.0
#define BALANCE_B 1.0

#define SEUIL 250

#define PLUGINS "plugins"
#define SEUIL_OFFSET 250
#define COEF_FLAT 10

enum {
  OFFSETS,
  LIGHTS,
  DARKS,
  FLATS,
  RESULTS
};


struct point
{
  int x;
  int y;
  uint32 intensite;
  struct point * suivant;
};
struct etoile
{
  struct point debut;
  struct point fin;
  uint32 intensite;
  uint16 vMax;
  float centre_X;
  float centre_Y;
  float FWHM;
  int indice;
  struct point * points;
  struct etoile * suivant;
  
};
struct triangle
{
  int iA;
  int iB;
  int iC;
  float xt;
  float yt;
  struct triangle *suivant;
};

int writeTiff(struct image *im, char *nFichier);
int loadTiff(char *nTiff,struct image * im,int needBuffer);


#endif

#ifndef LEN_REPERTOIRES
#define LEN_REPERTOIRES 5
extern const char * REPERTOIRES[LEN_REPERTOIRES];
#endif
