/*
   image.c -- APA 
   Copyright 2007 by David Laine, david dot laine a free o fr

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
   
 */

#include "image.h"

// methode de MAJ d'un pixel d'une image

void ImMajRGB16(struct image * im,unsigned long x,unsigned long y,
		uint16 R, uint16 G, uint16 B)
{

  unsigned long count;
  count = (y*im->width+ x)*6;
  im->buffer[count+1]=R/256;
  im->buffer[count  ]=R-im->buffer[count+1]*256;
  im->buffer[count+3]=G/256;
  im->buffer[count+2]=G-im->buffer[count+3]*256;
  im->buffer[count+5]=B/256;
  im->buffer[count+4]=B-im->buffer[count+5]*256;
}

void ImMajI16(struct image * im,unsigned long x,unsigned long y,
	      uint16 I, uint16 notUseG, uint16 notUseB)
{

  unsigned long count;
  count = 2*(y*im->width+ x);
  im->buffer[count+1]=I/256;
  im->buffer[count  ]=I-im->buffer[count+1]*256;
}

void ImMajRGB8(struct image * im,unsigned long x,unsigned long y,
		uint16 R, uint16 G, uint16 B)
{

  unsigned long count;
  count = (y*im->width+ x)*3;
  im->buffer[count]=R;
  im->buffer[++count]=G;
  im->buffer[++count]=B;
}

void ImMajI8(struct image * im,unsigned long x,unsigned long y,
	      uint16 I, uint16 notUseG, uint16 notUseB)
{

  unsigned long count;
  count = (y*im->width+ x);
  im->buffer[count]=I;

}

_ImMaj  DefImMaj(struct image * im)
{

  //printf ("%d %d %d %d \n",&ImValRGB8,&ImValI8, &ImValRGB16,&ImValI16);
  if (im->bps==8)
    {
      if (im->sampleParPixel==3)
	return &ImMajRGB8;
      if (im->sampleParPixel==1)
	return &ImMajI8;
    }
  if (im->bps==16)
    {
      if (im->sampleParPixel==3)
	return &ImMajRGB16;
      if (im->sampleParPixel==1)
	return &ImMajI16;
    }
  return NULL;
}


// methodes d'acces aux images

void ImValRGB8(struct image * im,unsigned long x,unsigned long y,
		uint16 *R, uint16 *G, uint16 *B)
{
/*   unsigned long count; */
/*   count = (y*im->width+ x)*3; */
/*   *R=im->buffer[count]; */
/*   *G=im->buffer[++count]; */
/*   *B=im->buffer[++count]; */

  unsigned char *ptr;
  ptr = im->buffer+(y*im->width+ x)*3;
  *R=*ptr++;
  *G=*ptr++;
  *B=*ptr++;


}
void ImValI8(struct image * im,unsigned long x,unsigned long y,
	      uint16 *I, uint16 *notUseG, uint16 *notUseB)
{
/*   unsigned long count; */
/*   count = y*im->width+ x; */
/*   uint16 v=im->buffer[count]; */
/*   *I=v; */
/*   *notUseG=v; */
/*   *notUseB=v; */

  unsigned char *ptr;
  ptr = im->buffer+(y*im->width+ x)*3;
  *I=*ptr;
  *notUseG=*ptr;
  *notUseB=*ptr;

}

void ImValRGB16(struct image * im,unsigned long x,unsigned long y,
		uint16 *R, uint16 *G, uint16 *B)
{

  //printf("imaval 16 : %i %i %i \n", *R,*G,*B);fflush(stdout);
  //unsigned long count;
  //count = (y*im->width+ x)*6;
  // Ces trois lignes peuvent etre
  //*R=im->buffer[count]+256*im->buffer[count+1];
  //*G=im->buffer[count+2]+256*im->buffer[count+3];
  //*B=im->buffer[count+4]+256*im->buffer[count+5];

  unsigned char *ptr;
  ptr = im->buffer+(y*im->width+ x)*6;
  char * val;

  val = (char *)R;
  *val = (*ptr);
  *(val+1) = (*++ptr);

  val = (char *)G;
  *val = (*++ptr);
  *(val+1) = (*++ptr);

  val = (char *)B;
  *val = (*++ptr);
  *(val+1) = (*++ptr);
  
/*   *R= (*ptr) + (*++ptr)*256; */
/*   *G= (*++ptr) + (*++ptr)*256; */
/*   *B= (*++ptr) + (*++ptr)*256; */

/*   *R=im->buffer[count]+256*im->buffer[++count]; */
/*   *G=im->buffer[++count]+256*im->buffer[++count]; */
/*   *B=im->buffer[++count]+256*im->buffer[++count]; */

}
void ImValI16(struct image * im,unsigned long x,unsigned long y,
	      uint16 *I, uint16 *notUseG, uint16 *notUseB)
{
/*   unsigned long count; */
/*   count = 2*(y*im->width+ x); */
/*   uint16 v=im->buffer[count]+256*im->buffer[++count]; */
/*   *I=v; */
/*   *notUseG=v; */
/*   *notUseB=v; */

  unsigned char *ptr;
  ptr = im->buffer+(y*im->width+ x)*2;
  char * val;

  val = (char *)I;*val = (*ptr);*(val+1) = (*++ptr);

  *notUseG=&I;
  *notUseB=&I;

}

_ImVal  DefImVal(struct image * im)
{

  //printf ("%d %d %d %d \n",&ImValRGB8,&ImValI8, &ImValRGB16,&ImValI16);
  if (im->bps==8)
    {
      if (im->sampleParPixel==3)
	return &ImValRGB8;
      if (im->sampleParPixel==1)
	return &ImValI8;
    }
  if (im->bps==16)
    {
      if (im->sampleParPixel==3)
	return &ImValRGB16;
      if (im->sampleParPixel==1)
	return &ImValI16;
    }
  return NULL;
}

